// ! Using Javascript Strict Mode
"use strict";

/**
 * * Global Variable
 */
let nvrSkuList = []; //*NVR Sku List
let nvrCapableCameraList = []; // * NVR Capable Camera Sku List
let nvrSkuBtn; //* NVR Sku Button Number
let totalCapableCamCount; //* Total Capable Camera Count
let totalPoc; //* Total Power Of Consumption
let junctionBoxForCameraList = []; //* Junction Box For Camera List
let TempJunctionBoxForCameraList = []; //* Temporary Store Junction Box For Camera List
let totalProductSelected = {};
let selectedCamera = []; //* Selected Camera List
let allJBox = [];
let selectedCamList = [];
let selectedIotList = [];
let iotproduct;
let accessoriesProduct;
let selectedCamerasList = [];
let recommendedCameraList = [];
/**
 * * NVR Compare Template
 * @function nvrCompareTemplate - NVR Compare Template
 * @param {Object} dataCompare - Json Data For NVR Compare
 */
const nvrCompareTemplate = (dataCompare) => {
  // * For Wired Compare
  // * Accessing DOM Element
  const nvrChannelTag = document.createElement("td");
  const nvrChannelContainer = document.querySelector(
    "#js-nvr-channel-container"
  );
  const nvrChannelTemplate = document.createTextNode(dataCompare["channels"]);

  //   * Appending HTML Template
  nvrChannelTag.appendChild(nvrChannelTemplate);
  nvrChannelContainer.appendChild(nvrChannelTag);
  nvrChannelTag.classList.add("color-black");

  // * For Wired Compare
  // * Accessing DOM Element
  const nvrWiredTag = document.createElement("td");
  const nvrWiredContainer = document.querySelector("#js-nvr-wired-container");
  const nvrWireTemplate = document.createTextNode(dataCompare["max_wired"]);

  //   * Appending HTML Template
  nvrWiredTag.appendChild(nvrWireTemplate);
  nvrWiredContainer.appendChild(nvrWiredTag);
  nvrWiredTag.classList.add("color-black");

  // * For Wireless Compare
  // * Accessing DOM Element
  const nvrWirelessTag = document.createElement("td");
  const nvrWirelessContainer = document.querySelector("#js-nvr-wl-container");
  const nvrWirelessTemplate = document.createTextNode(
    dataCompare["max_wifi"] ? dataCompare["max_wifi"] : "..."
  );
  // dataCompare["max_wifi"]
  // ? nvrWirelessTag.classList.add("color-black")
  // : nvrWirelessTag.classList.add("font-weight");
  //   * Appending HTML Template
  nvrWirelessTag.appendChild(nvrWirelessTemplate);
  nvrWirelessContainer.appendChild(nvrWirelessTag);

  // * For FPS Compare
  // * Accessing DOM Element
  const nvrFpsTag = document.createElement("td");
  const nvrFpsContainer = document.querySelector("#js-nvr-fps-container");
  const nvrFpsTemplate = document.createTextNode(
    dataCompare["max_fps"] ? dataCompare["max_fps"] : "..."
  );

  //   * Appending HTML Template
  nvrFpsTag.appendChild(nvrFpsTemplate);
  nvrFpsContainer.appendChild(nvrFpsTag);
  nvrFpsTag.classList.add("no-bot-bor");

  // * For Local Storage Compare
  // * Accessing DOM Element
  const nvrLsTag = document.createElement("td");
  const nvrLsContainer = document.querySelector("#js-nvr-ls-container");
  const nvrLsTemplate = document.createTextNode(
    dataCompare["storage"] ? dataCompare["storage"] : "..."
  );

  //   * Appending HTML Template
  nvrLsTag.appendChild(nvrLsTemplate);
  nvrLsContainer.appendChild(nvrLsTag);
  nvrLsTag.classList.add("no-bot-bor");

  // * For Local Storage Compare
  // * Accessing DOM Element
  const nvrCocTag = document.createElement("td");
  const nvrCocContainer = document.querySelector("#js-nvr-coc-container");
  const nvrCocTemplate = document.createTextNode(
    dataCompare["lorex_app"] ? dataCompare["lorex_app"] : "..."
  );

  //   * Appending HTML Template
  nvrCocTag.appendChild(nvrCocTemplate);
  nvrCocContainer.appendChild(nvrCocTag);
  nvrCocTag.classList.add("no-bot-bor");
};

/**
 * * Showing NVR List
 * @function nvrProduct - Show NVR Product
 * @param {Object} dataJson - Json Data For NVR Details
 */
const nvrProduct = (dataJson) => {
  // * Extracting Array
  dataJson["item"].forEach((nvrProduct) => {
    // * Only NVR Item Allow
    if (nvrProduct["product_type"] === "NVR") {
      // * Creating NVR Sku List Into Array
      nvrSkuList.push(nvrProduct["sku"]);

      // * Showing In HTML
      const nvrProductContainer = document.querySelector("#js-nvr-product");
      nvrProductContainer.innerHTML += `<td>
      <div class="card" style="${
        nvrProduct["sku"] == "N843A82" ? `width:100%` : `width:100%`
      }">
        <div class="img-wrapper">
           <!--<span class="recom">Recommended</span> -->
          
          ${
            nvrProduct["max_wifi"] > 0
              ? `<span class="recom badge">Fusion</span>`
              : ""
          }
          <a href="${
            nvrProduct["link"]
          }" target="_blank"  rel="noreferrer " class="text-decoration-none nvr-next-btn-on-image" style="display:block">${`<img
            src="${nvrProduct["image_link"]}"
            class="card-img-top"
            alt="${nvrProduct["title"]}"
          />`}</a>
        </div>
        <div class="card-body">
      
          <h5 class="card-title">
          <a href="${
            nvrProduct["link"]
          }" target="_blank"  rel="noreferrer " class="text-decoration-none nvr-next-btn-on-image"" style="display:block">${
        nvrProduct["sku"] == "N882A38B-W"
          ? nvrProduct["title"] + "&nbsp;<br>&nbsp;"
          : nvrProduct["title"]
      }</a>
            
          </h5>
        
          <ul class="features">
            <li>${nvrProduct["sku"]}</li>
            
            <li>${nvrProduct["poe_budget"]}W</li>
          </ul>
          <div class="yotpo bottomLine"
              data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
              data-domain="{{shop.permanent_domain | escape }}"
              data-product-id="{{ product.id }}"
              data-product-models="{{ product.id }}"
              data-name="{{ product.title | escape }}"
              data-url="{{ shop.url }}{{ product.url }}"
              data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
              data-description="{{ product.description | escape }}"
              data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
            </div>
            <div class="yotpo bottomLine"
              data-product-id="{{ ${nvrProduct["id"]} }}">
            </div>
          <p class="price">$${Number(
            nvrProduct["bundle_builder_price"]
              ? nvrProduct["bundle_builder_price"]
              : nvrProduct["sale_price"]
          ).toFixed(2)}
          ${
            nvrProduct["bundle_builder_price"] != ""
              ? `<span class="msrp-price"><del>$${Number(
                  nvrProduct["sale_price"]
                ).toFixed(2)}</del></span>
          </p>`
              : ""
          }
		    <a href="${
          nvrProduct["link"]
        }" target="_blank"  rel="noreferrer " class="text-decoration-none">learn more</a>
			<div class="line">
          <div class="quantity buttons_added">
          <!--
            <input
              type="button"
              value="-"
              class="minus js-nvr-count-btn"
            />
            -->
            <a
            href="javascript:void(0);"
            class="btn btn-primary" id="${nvrProduct["sku"]}" data-sku="${
        nvrProduct["sku"]
      }"
            >
            <svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" width="35px" height="20px" viewBox="0 0 122.877 101.052" enable-background="new 0 0 122.877 101.052" xml:space="preserve"><g><path d="M4.43,63.63c-2.869-2.755-4.352-6.42-4.427-10.11c-0.074-3.689,1.261-7.412,4.015-10.281 c2.752-2.867,6.417-4.351,10.106-4.425c3.691-0.076,7.412,1.255,10.283,4.012l24.787,23.851L98.543,3.989l1.768,1.349l-1.77-1.355 c0.141-0.183,0.301-0.339,0.479-0.466c2.936-2.543,6.621-3.691,10.223-3.495V0.018l0.176,0.016c3.623,0.24,7.162,1.85,9.775,4.766 c2.658,2.965,3.863,6.731,3.662,10.412h0.004l-0.016,0.176c-0.236,3.558-1.791,7.035-4.609,9.632l-59.224,72.09l0.004,0.004 c-0.111,0.141-0.236,0.262-0.372,0.368c-2.773,2.435-6.275,3.629-9.757,3.569c-3.511-0.061-7.015-1.396-9.741-4.016L4.43,63.63 L4.43,63.63z" fill="#fff"></path></g></svg>
            </a
          >
              
            <!--
            <input type="button" value="+" class="plus js-nvr-count-btn" />
            -->
          </div>
          
          <a
            href="javascript:void(0);"
            class="btn btn-primary js-nvr-add-btn" id="${
              nvrProduct["sku"]
            }" data-sku="${nvrProduct["sku"]}"
            >Select</a
          >
		  <label class="compare">
		  <input type="checkbox" name="compare" data-sku="${
        nvrProduct["sku"]
      }"> Compare</label>
        </div></div>
      </div>
    </td>`;

      // * NVR Compare Template
      // nvrCompareTemplate(nvrProduct);
    }
  });
};

/**
 * * Next Button Click Event On First Step
 * @function nextBtnAction1 - Next Button Action
 * @param {Object} nvrSku - JSON Data For NVR Sku
 */
const nextBtnAction1 = (nvrSku) => {
  // * When Click On Next Button and Step 2
  // ! It Use jQuery for Detect Step. Use JavaScript or ES6
  $(document).on("click", "#next[data-step=2]", function () {
    // * For Next Button Not Show in Compare
    // $(".next-step").removeClass("next-btn");
    // $(".pre-step").removeClass("pre-btn");
    // $("#next-arrow, #pre-arrow").removeClass("icon-arrow");

    $("#js-main-container").removeClass("col-md-12");

    if (
      /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(
        navigator.userAgent
      )
    ) {
      // some code..
      $(".hide-shopping-home").show();
    }
    // * Show IOT Disclaimer
    if (
      productInfo[nvrSkuBtn]["max_wifi"] == "" ||
      productInfo[nvrSkuBtn]["max_wifi"] == 0
    ) {
      $(document).find("#greater-wifi").hide();
      $(document).find("#zero-wifi").show();
    } else {
      $(document).find("#greater-wifi").show();
      $(document).find("#zero-wifi").hide();
    }

    $(document).width() <= "764" ? $(".only-first").css("display", "none") : ``;
    $("#js-main-container").addClass("col-md-9");
    if (addPocText > totalPoc) {
      $("#cartupModal").modal("show");
      document.querySelector("#js-select-nvr").innerText =
        productInfo[nvrSkuBtn]["title"];

      document.querySelector("#js-select-nvr-poc").innerText =
        productInfo[nvrSkuBtn]["poe_budget"];
      clearShowSelectedCamTemplate("#js-select-cam");
      showSelectedCam("#js-select-cam");

      document.querySelector("#total-cam-poc-cal").innerText =
        parseFloat(addPocText).toFixed(2);

      document.querySelector("#total-nvr-poc-cal").innerText = totalPoc;
      document.querySelector("#extra-poc-cam").innerText = (
        parseFloat(addPocText).toFixed(2) - parseFloat(totalPoc)
      ).toFixed(2);
    } else {
      currentStep = 2;
      if (currentStep != totalStep) {
        stepHTML.innerText = currentStep;
      } else {
        stepHTML.innerText = 4;
        return;
      }
      currentProgressBar(currentStep);

      // * Checking NVR Sku in NVR Sku Array List
      if (nvrSkuList.includes(nvrSkuBtn)) {
        // * If NVR Sku is Present in NVR Sku Array List
        nvrSku["item"].forEach((nvrOneItem) => {
          //  * If NVR Sku is Present in product Json
          if (nvrSkuBtn === nvrOneItem["sku"]) {
            // * Show in HTML
            const selectedNvr = $(".js-selected-nvr");
            const selectedNvrHTML = `<img src="${
              nvrOneItem["image_link"]
            }" alt="${nvrOneItem["title"]}"/>
          <div class="on-selection-detail">
            <h4>${nvrOneItem["title"]}</h4>
            <p>Qty - <span>${
              nvrQuantity === undefined ? 1 : nvrQuantity
            }</span></p>
          </div>
          <div class="change js-change-recorder" role="button" >Edit</div>`;
            selectedNvr.html(selectedNvrHTML);
            /**
             * * Show Total Capable Camera Count Based On Channels
             * * If Client Select 2 NVR Of Same Type Then Total Will Be 2 * NVR Channel
             */
            totalCapableCamCount =
              parseInt(nvrOneItem["channels"]) *
              (nvrQuantity === undefined ? 1 : nvrQuantity);
            // * Max Camera is Equal To Total Capable Camera Count Channel
            maxCameraSelect = totalCapableCamCount;

            // * Show In HTML
            document.querySelector("#js-total-capable-cam-count").innerText =
              totalCapableCamCount;

            /**
             * * Show Total Power Of Consumption
             * * If Client Select 2 NVR Then Power Of Consumption Will Be 2 * NVR Power
             */
            totalPoc =
              parseInt(nvrOneItem["poe_budget"]) *
              (nvrQuantity === undefined ? 1 : nvrQuantity);
            // * Show In HTML
            document.querySelector("#js-total-poc").innerHTML = totalPoc;

            // * Show NVR In Product HighLight
            nvrProductHightLight(nvrOneItem);
          }
        });
        // * Showing NVR Related Camera
        ShowNvrRelatedCamera(nvrSku, nvrSkuBtn);
      }

      // * Showing Capable Camera Count
      document.querySelector("#js-capable-cam-count").innerText = parseInt(
        nvrCapableCameraList.length
      );
      // * Junction Box Template
      // junctionBoxTemplate(nvrSku);
      Object.defineProperty(totalProductSelected, "nvr", {
        value: { sku: nvrSkuBtn, quantity: nvrQuantity },
        writable: true,
      });
    }

    mobileCartNumber();

    // * Adding IOT Count
    // & HTML Injection
    $(document).find(".total-iot").text(productInfo[nvrSkuBtn]["max_wifi"]);

    // * Show Hard Disk Compatible with NVR
    let hardDiskSku = productInfo[nvrSkuBtn]["compatible_hdds"].split(",");
    document.querySelector("#hardDriveTemplate").innerHTML = "";
    hardDiskSku.forEach((skuEl) => {
      // * Show Hard Disk Template
      showAccessories(skuEl, "#hardDriveTemplate");
    });

    //
    $("#previous-btn").css("display", "block");
    $("#previous-btn").attr("data-step", "2");

    $(this).attr("disabled", true);
  });
};

// * For Previous Button NVR
$(document).on("click", "#previous-btn[data-step=2]", function () {
  $(document).find(".js-change-recorder").trigger("click");
});

// * For Previous Button Camera
$(document).on("click", "#previous-btn[data-step=3]", function () {
  $(document).find(".js-change-camera").trigger("click");
});
// * For Previous Button IOT
$(document).on("click", "#previous-btn[data-step=4]", function () {
  $(document).find(".js-change-iot").trigger("click");
});

// * For Summary Previous Button
$(document).on("click", "#previous-summary", function (e) {
  e.preventDefault();
  $(".step4.steps").show();
  $(".main-div.py-3").show();
  $(".cart-section").hide();

  // showAccessoriesTab();

  $(document).find(".js-accessories-tab").removeClass("active");
  $(document).find("#myTab2 > li:visible:first").find("a").addClass("active");

  $(document)
    .find("#myTab2 ~ div:first")
    .find("div:visible:first")
    .addClass("active");

  let activeId = $(document).find("#myTab2").find(".active").attr("href");
  // console.log(activeId);

  $(document)
    .find(".suggest-js-accessories-tab")
    .find(activeId)
    .addClass("active show");
  productSelectedList = [];

  let discountPrice =
    productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"] !== ""
      ? productInfo[totalProductSelected.nvr.sku]["sale_price"] -
        productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"]
      : 0;

  productSelectedList.push(
    [
      totalProductSelected.nvr.sku,
      totalProductSelected.nvr.quantity,
      discountPrice,
    ],
    ...selectedCamera,
    ...selectedIotList
  );
  productHighlightTemplate();
  productHighlightPrice();
  restoreHardDisk();

  mobileCartNumber();
});
/**
 * Show Hard Disk Template
 * @function showAccessories
 * @param {String} Accessories - Hard Disk SKU
 * @param {String} htmlId - HTML ID
 * @return {String} - Return HTML
 */
const showAccessories = (Accessories, htmlId) => {
  const ACCESSORIES_LIST = document.querySelector(htmlId);

  if (productInfo[Accessories] !== undefined) {
    // & HTML Injection
    ACCESSORIES_LIST.innerHTML += `
<div class="col-md-3">
  <div class="card" data-sku="${productInfo[Accessories]["sku"]}">
  <div class="img-wrapper">

    <a href="${
      productInfo[Accessories]["link"]
    }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${`<img
      src="${productInfo[Accessories]["image_link"]}"
      class="card-img-top"
      alt="${productInfo[Accessories]["title"]}"
    />`}</a>
    
  </div>
  <div class="card-body">

    <h5 class="card-title">
    <a href="${
      productInfo[Accessories]["link"]
    }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${
      productInfo[Accessories]["title"]
    }</a>
    </h5>
  
    <ul class="features">
      <li>${productInfo[Accessories]["sku"]}</li>
    </ul>
    <div class="yotpo bottomLine"
    data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
    data-domain="{{shop.permanent_domain | escape }}"
    data-product-id="{{ product.id }}"
    data-product-models="{{ product.id }}"
    data-name="{{ product.title | escape }}"
    data-url="{{ shop.url }}{{ product.url }}"
    data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
    data-description="{{ product.description | escape }}"
    data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
  </div>
  <div class="yotpo bottomLine"
    data-product-id="{{ ${productInfo[Accessories]["id"]} }}">
  </div>
    <p class="price">$${
      productInfo[Accessories]["bundle_builder_price"]
        ? productInfo[Accessories]["bundle_builder_price"]
        : productInfo[Accessories]["sale_price"]
    }</p>
  <a href="${
    productInfo[Accessories]["link"]
  }" target="_blank"  rel="noreferrer" class="text-decoration-none">learn more</a>
    <div class="quantity buttons_added">
      <input type="button" value="-" class="minus js-hdd-count-btn" data-sku="${
        productInfo[Accessories]["sku"]
      }"/><input
        type="text" maxlength="2"
        step="1"
        min="0"
        max=""
        name="quantity"
        value="1"
        title="Qty"
        class="input-text qty text js-hdd-count-input"
        size="4"
        pattern="[0-9]*" inputmode="numeric" data-sku="${
          productInfo[Accessories]["sku"]
        }" onkeypress="return validateNumber(event)"
      /><input type="button" value="+" class="plus js-hdd-count-btn" data-sku="${
        productInfo[Accessories]["sku"]
      }" />
    </div>
    <a href="javascript:void(0);" class="btn btn-primary js-hard-disk" data-sku="${
      productInfo[Accessories]["sku"]
    }"
      >Add</a
    >
    
  </div>
</div></div>
`;
  }
};

/**
 * * Next Button Click Event On
 * @function nextBtnAction - Next Button Action
 * @param {Object} nvrData - JSON Sku Data
 */
const nextBtnAction = (nvrData) => {
  // * When Click On Next Button If Data Set is One
  nextBtnAction1(nvrData);
  // * When Click On Next Button and Step 2
  // ! It Use jQuery for Detect Step. Use JavaScript or ES6
  $(document).on("click", "#next[data-step=2]", function () {
    productHighlightPrice();
  });

  // nextBtnAction2();
};

/**
 * * Getting NVR Sku When Click On NVR Add Button
 * @function GetNvrSku - Getting NVR Sku When Click On NVR Add Button
 * @param {Object} nvrSku - JSON Sku Data
 */
const GetNvrSku = () => {
  document.body.addEventListener("click", (event) => {
    if (event.target.classList.contains("js-nvr-add-btn")) {
      nvrSkuBtn = event.target.getAttribute("data-sku");
    }
  });
};

/**
 * * Junction Box For Camera
 * @function cameraJunctionBox - Camera Junction Box
 * @param {Object} cameraData - JSON Camera Data
 */
const junctionBoxForCamera = (cameraData) => {
  // * Storing Junction Box On Temporary Variable
  TempJunctionBoxForCameraList.push(cameraData["compatible_junctionbox"]);

  // * Storing Unique Junction Box
  // * First Covert 'TempJunctionBoxForCameraList' Into String and Break Into Comma
  junctionBoxForCameraList = [
    ...new Set(TempJunctionBoxForCameraList.toString().split(",")),
  ];
};

/**
 * * Junction Box Template
 * @function junctionBoxTemplate - Junction Box Template
 * @param {Object} junctionBoxData - Json Data for Junction Box
 */
// const junctionBoxTemplate = (junctionBoxData) => {
//   // * Extracting Json Data
//   junctionBoxData["item"].forEach((junctionBox) => {
//     allJBox.push(junctionBox["sku"]);

//     // * Checking Junction Box's Sku Are Available In Junction Box List
//     if (junctionBoxForCameraList.includes(junctionBox["sku"])) {
//       // * Showing In HTML
//       const junctionBoxContainer = document.querySelector(
//         "#js-j-box-container"
//       );

//       junctionBoxContainer.innerHTML += `<div class="card">
//       <div class="img-wrapper">
//       <a href="${junctionBox["link"]}" target="_blank"  rel="noreferrer">
//         <img
//           src="${junctionBox["image_link"]}"
//           class="card-img-top"
//           alt="${junctionBox["title"]}"
//         />
//         </a>
//       </div>
//       <div class="card-body">
//       <a href="${junctionBox["link"]}" target="_blank"  rel="noreferrer" class="text-decoration-none">
//         <h5 class="card-title">${junctionBox["title"]}</h5>
//         </a>
//         <ul class="features">
//           <li>${junctionBox["sku"]}</li>
//           <li><img src="img/small.svg" /></li>
//           <li>640mA / 7.68W</li>
//         </ul>
//         <div class="rating">
//           <img src="img/star.svg" /><img
//             src="img/star.svg"
//           /><img src="img/star.svg" /><img
//             src="img/star.svg"
//           /><img src="img/star.svg" /><span>(33)</span>
//         </div>
//         <p class="price">$${junctionBox["sale_price"]}</p>
//         <div class="quantity buttons_added">
//           <input type="button" value="-" class="minus js-j-box-count-btn" data-sku="${junctionBox["sku"]}"/><input
//             type="number"
//             step="1"
//             min="0"
//             max=""
//             name="quantity"
//             value="1"
//             title="Qty"
//             class="input-text qty text"
//             size="4"
//             pattern=""
//             inputmode=""
//           /><input type="button" value="+" class="plus js-j-box-count-btn" data-sku="${junctionBox["sku"]}" />
//         </div>
//         <a href="javascript:void(0);" class="btn btn-primary js-junction-box" data-sku="${junctionBox["sku"]}"
//           >Add</a
//         >
//       </div>
//     </div>`;
//     }
//   });
// };

const junctionBoxTemplate = (data) => {
  const junctionBoxContainer = document.querySelector("#jBoxTemplate");
  junctionBoxContainer.innerHTML += `
  <div class="col-md-3">
  <div class="card" data-sku="${productInfo[data]["sku"]}">
  <div class="img-wrapper">
 
  <a href="${
    productInfo[data]["link"]
  }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${`<img
    src="${productInfo[data]["image_link"]}"
    class="card-img-top"
    alt="${productInfo[data]["title"]}"
  />`}</a>
    
  </div>
  <div class="card-body">
  
    <h5 class="card-title">
    <a href="${
      productInfo[data]["link"]
    }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${
    productInfo[data]["title"]
  }</a>
    </h5>
   
    <ul class="features">
      <li>${productInfo[data]["sku"]}</li>
    </ul>
    <div class="yotpo bottomLine"
    data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
    data-domain="{{shop.permanent_domain | escape }}"
    data-product-id="{{ product.id }}"
    data-product-models="{{ product.id }}"
    data-name="{{ product.title | escape }}"
    data-url="{{ shop.url }}{{ product.url }}"
    data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
    data-description="{{ product.description | escape }}"
    data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
  </div>
  <div class="yotpo bottomLine"
    data-product-id="{{ ${productInfo[data]["id"]} }}">
  </div>
    <p class="price">$${Number(
      productInfo[data]["bundle_builder_price"]
        ? productInfo[data]["bundle_builder_price"]
        : productInfo[data]["sale_price"]
    ).toFixed(2)}</p>
	<a href="${
    productInfo[data]["link"]
  }" target="_blank"  rel="noreferrer" class="text-decoration-none">learn more</a>
    <div class="quantity buttons_added">
      <input type="button" value="-" class="minus js-j-box-count-btn" data-sku="${
        productInfo[data]["sku"]
      }"/><input
        type="text" maxlength="2"
        step="1"
        min="0"
        max=""
        name="quantity"
        value="1"
        title="Qty"
        class="input-text qty text js-jbox-count-input"
        size="4"
        pattern="[0-9]*" inputmode="numeric" data-sku="${
          productInfo[data]["sku"]
        }" onkeypress="return validateNumber(event)"
      /><input type="button" value="+" class="plus js-j-box-count-btn" data-sku="${
        productInfo[data]["sku"]
      }" />
    </div>
    <a href="javascript:void(0);" class="btn btn-primary js-junction-box" data-sku="${
      productInfo[data]["sku"]
    }"
      >Add</a
    >
    
  </div>
</div>
</div>

`;
};

const delJunctionBoxTemplate = () => {
  const junctionBoxContainer = document.querySelector("#jBoxTemplate");

  junctionBoxContainer.innerHTML = "";
};
/**
 * * Showing NVR Related Camera Template
 * @function nvrRelatedCameraTemplate - Showing NVR Related Camera Template
 * @param {JSON} cameraData - Camera Data
 */
const ShowNvrRelatedCameraTemplate = (cameraData) => {
  const nvrRelatedCamera = document.querySelector("#js-nvr-related-cam");
  nvrRelatedCamera.innerHTML = "<th></th>";
  cameraData["item"].forEach((camera) => {
    // * Check If Camera Sku is Present in NVR Sku Array List

    if (nvrCapableCameraList.includes(camera["sku"])) {
      // * Showing In HTML
      nvrRelatedCamera.innerHTML += `<td data-sku="${camera["sku"]}">
        <div class="card">
          <div class="img-wrapper">
          ${
            recommendedCameraList.includes(camera["sku"])
              ? `<span class="recom">Recommended</span>`
              : ""
          }
           <!-- <span class="recom">Recommended</span> -->
         
            <a href="${
              camera["link"]
            }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${`<img
              src="${camera["image_link"]}"
              class="card-img-top"
              alt="${camera["title"]}"
            />`}</a>
          
          </div>
          <div class="card-body">
         
            <h5 class="card-title">
            <a href="${
              camera["link"]
            }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${
        camera["title"]
      }</a>
            
            </h5>
            
            <ul class="features">
              <li>${camera["sku"]}</li>
              
              <li> ${camera["poe_consumption"]}W</li>
            </ul>
            <div class="yotpo bottomLine"
              data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
              data-domain="{{shop.permanent_domain | escape }}"
              data-product-id="{{ product.id }}"
              data-product-models="{{ product.id }}"
              data-name="{{ product.title | escape }}"
              data-url="{{ shop.url }}{{ product.url }}"
              data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
              data-description="{{ product.description | escape }}"
              data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
            </div>
            <div class="yotpo bottomLine"
              data-product-id="{{ ${camera["id"]} }}">
            </div>
              <p class="price">$${Number(
                camera["bundle_builder_price"]
                  ? camera["bundle_builder_price"]
                  : camera["sale_price"]
              ).toFixed(2)}
              ${
                camera["bundle_builder_price"] != ""
                  ? `<span class="msrp-price"><del>$${Number(
                      camera["sale_price"]
                    ).toFixed(2)}</del></span>
              </p>`
                  : ""
              }
			 <a href="${
         camera["link"]
       }" target="_blank"  rel="noreferrer" class="text-decoration-none">learn more</a>
           
			<div class="line">
		   <div class="quantity buttons_added">
              <input
                type="button"
                value="-"
                class="minus js-camera-count-btn" data-sku="${
                  camera["sku"]
                }" data-poc=${camera["poe_consumption"]}
              /><input
                type="text" maxlength="2"
                step="1"
                min="0"
                max="99"
                name="quantity"
                value="1"
                title="Qty"
                class="input-text qty text js-camera-count-input"
                size="4"
                pattern="[0-9]*" inputmode="numeric" data-sku="${
                  camera["sku"]
                }" data-poc=${
        camera["poe_consumption"]
      } onkeypress="return validateNumber(event)"
              /><input type="button" value="+" class="plus js-camera-count-btn" data-sku="${
                camera["sku"]
              }" data-poc=${camera["poe_consumption"]}/>
            </div>
            <a
              href="javascript:void(0);"
              class="btn btn-primary js-camera-add-btn" data-poc=${
                camera["poe_consumption"]
              } data-sku="${camera["sku"]}"
              >Add</a
            >
            <label class="compare">
		  <input type="checkbox" name="compare-cam" data-sku="${
        camera["sku"]
      }"> Compare</label>
		  </div>
          </div>
        </div>
      </td>`;

      // * Camera Compare Template

      junctionBoxForCamera(camera);
    }
  });
};

/**
 * * Camera Compare Template
 * @param {Object} cameraData - Json Data For Camera Campare
 * @function NvrRelatedCameraCompare - Camera Compare Template
 */
const NvrRelatedCameraCompare = (cameraData) => {
  // * For Camera Quality Compare
  const camera_td_tag = document.createElement("td");
  const cameraResContainer = document.querySelector("#js-cam-res-container");
  const camera_Res_template = document.createTextNode(
    cameraData["comparison_resolution"]
  );
  camera_td_tag.appendChild(camera_Res_template);
  cameraResContainer.appendChild(camera_td_tag);

  // * For Camera Audio Compare
  const camera_audio_tag = document.createElement("td");
  const cameraAudioContainer = document.querySelector(
    "#js-cam-audio-container"
  );
  const camera_audio_template = document.createTextNode(
    cameraData["comparison_audio"] ? cameraData["comparison_audio"] : "..."
  );
  // cameraData["comparison_audio"]
  // ? camera_audio_tag.classList.add("color-black")
  // : camera_audio_tag.classList.add("font-weight");
  camera_audio_tag.appendChild(camera_audio_template);
  cameraAudioContainer.appendChild(camera_audio_tag);

  // * For Camera Smart Detection Compare
  const camera_SDetect_tag = document.createElement("td");
  const cameraSDetectContainer = document.querySelector(
    "#js-cam-s-detect-container"
  );
  const camera_SDetect_template = document.createTextNode(
    cameraData["comparison_detection"]
      ? cameraData["comparison_detection"]
      : "..."
  );
  camera_SDetect_tag.appendChild(camera_SDetect_template);
  cameraSDetectContainer.appendChild(camera_SDetect_tag);

  // * For Camera Smart Detection Compare
  const camera_NVision_tag = document.createElement("td");
  const cameraNVisionContainer = document.querySelector(
    "#js-cam-n-vision-container"
  );
  const camera_NVision_template = document.createTextNode(
    cameraData["comparison_nightvision"]
      ? `${cameraData["comparison_nightvision"]}FT`
      : "..."
  );
  camera_NVision_tag.appendChild(camera_NVision_template);
  cameraNVisionContainer.appendChild(camera_NVision_tag);

  // * For Camera Field Of View Compare
  const camera_FOV_tag = document.createElement("td");
  const cameraFOVContainer = document.querySelector("#js-cam-fov-container");
  const camera_FOV_template = document.createTextNode(
    cameraData["comparison_fov"] ? cameraData["comparison_fov"] : "..."
  );
  camera_FOV_tag.appendChild(camera_FOV_template);
  cameraFOVContainer.appendChild(camera_FOV_tag);

  // * For Camera FPS Compare
  const camera_FPS_tag = document.createElement("td");
  const cameraFPSContainer = document.querySelector("#js-cam-fps-container");
  const camera_FPS_template = document.createTextNode(
    cameraData["max_fps"] ? cameraData["max_fps"] : "..."
  );
  camera_FPS_tag.appendChild(camera_FPS_template);
  cameraFPSContainer.appendChild(camera_FPS_tag);

  // * For Camera Deterrence Compare
  const camera_dr_tag = document.createElement("td");
  const cameraDrContainer = document.querySelector(
    "#js-cam-deterrence-container"
  );
  const camera_dr_template = document.createTextNode(
    cameraData["comparison_deterrence"]
      ? cameraData["comparison_deterrence"]
      : "..."
  );
  // cameraData["comparison_deterrence"]
  // ? camera_dr_tag.classList.add("color-black")
  // : camera_dr_tag.classList.add("font-weight");
  camera_dr_tag.appendChild(camera_dr_template);
  cameraDrContainer.appendChild(camera_dr_tag);
  // * For Camera Color Night Vision Compare
  const camera_cnv_tag = document.createElement("td");
  const cameraCnvContainer = document.querySelector("#js-cam-cnv-container");
  const camera_cnv_template = `<td>${
    cameraData["comparison_cnv"] == "Color Night Vision"
      ? '<img src="img/dark-tick.svg" />'
      : '<img src="img/cross-light.svg" />'
  }</td>`;
  cameraCnvContainer.insertAdjacentHTML("beforeend", camera_cnv_template);
  // cameraData["comparison_cnv"]
  //   ? camera_cnv_tag.classList.add( "color-black")
  //   : camera_cnv_tag.classList.add("font-weight");
  // camera_cnv_tag.appendChild(camera_cnv_template);
  // cameraCnvContainer.appendChild(camera_cnv_tag);

  // * For Camera Lens Type Compare
  const camera_l_type_tag = document.createElement("td");
  const cameraLTypeContainer = document.querySelector(
    "#js-cam-ltype-container"
  );
  const cameral_type_template = document.createTextNode(
    cameraData["comparison_lenstype"]
      ? cameraData["comparison_lenstype"]
      : "..."
  );
  // cameraData["comparison_lenstype"]
  // ? camera_l_type_tag.classList.add("color-black")
  // : camera_l_type_tag.classList.add("font-weight");
  camera_l_type_tag.appendChild(cameral_type_template);
  cameraLTypeContainer.appendChild(camera_l_type_tag);

  // * For Camera Color  Compare
  const camera_color_tag = document.createElement("td");
  const cameraColorContainer = document.querySelector(
    "#js-cam-color-container"
  );
  const camera_color_template = document.createTextNode(
    cameraData["comparison_color"] ? cameraData["comparison_color"] : "..."
  );
  // cameraData["comparison_style"]
  // ? camera_color_tag.classList.add("color-black")
  // : camera_color_tag.classList.add("font-weight");
  camera_color_tag.appendChild(camera_color_template);
  cameraColorContainer.appendChild(camera_color_tag);

  // * For Camera Camera Style Compare
  const camera_style_tag = document.createElement("td");
  const cameraStyleContainer = document.querySelector(
    "#js-cam-style-container"
  );
  const cameraStyle_template = document.createTextNode(
    cameraData["comparison_style"] ? cameraData["comparison_style"] : "..."
  );
  // cameraData["comparison_style"]
  // ? camera_style_tag.classList.add("color-black")
  // : camera_style_tag.classList.add("font-weight");
  camera_style_tag.appendChild(cameraStyle_template);
  cameraStyleContainer.appendChild(camera_style_tag);

  // * For Camera  Rating Compare
  const camera_iprating_tag = document.createElement("td");
  const cameraIPratingContainer = document.querySelector(
    "#js-cam-iprating-container"
  );
  const cameraiprating_template = document.createTextNode(
    cameraData["comparison_iprating"]
      ? cameraData["comparison_iprating"]
      : "..."
  );
  // cameraData["comparison_iprating"]
  // ? camera_iprating_tag.classList.add("color-black")
  // : camera_iprating_tag.classList.add("font-weight");
  camera_iprating_tag.appendChild(cameraiprating_template);
  cameraIPratingContainer.appendChild(camera_iprating_tag);
};

const NvrClearRelatedCameraCompare = () => {
  // * For Camera Quality Compare
  const cameraResContainer = document.querySelector("#js-cam-res-container");
  cameraResContainer.innerHTML = `<th style="display: block">
<a
  class="tip"
  data-toggle="tooltip" 
  title="A numerical value that indicates the pixels that can be displayed in each dimension for computer monitors, television screens and display devices."
  ><img src="img/imp.png" /> Maximum Resolution</a
>
</th>`;

  // * For Camera Audio Compare
  const cameraAudioContainer = document.querySelector(
    "#js-cam-audio-container"
  );
  cameraAudioContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
  data-toggle="tooltip" 
  title="Security cameras with listen-in audio come with a built-in microphone that can hear and record audio. Two-way talk cameras also include a speaker that allows you to communicate to those within earshot of the camera."
  ><img src="img/imp.png" /> Audio</a
>
</th>`;
  // * For Camera Smart Detection Compare
  const cameraSDetectContainer = document.querySelector(
    "#js-cam-s-detect-container"
  );
  cameraSDetectContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
   data-toggle="tooltip" 
  title="A capability of video surveillance systems to identify movement in its field of view and to record these incidents."
  ><img src="img/imp.png" /> Motion Detection</a
>
</th>`;
  // * For Camera Smart Detection Compare

  const cameraNVisionContainer = document.querySelector(
    "#js-cam-n-vision-container"
  );
  cameraNVisionContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
  <a

    class="tip"
    data-toggle
     data-toggle="tooltip" 
  title="Camera's maximum range for recording black and white video footage in regular nighttime conditions."
    ><img src="img/imp.png" /> Night Vision</a
  >
</th>`;

  // * For Camera Field Of View Compare
  const cameraFOVContainer = document.querySelector("#js-cam-fov-container");
  cameraFOVContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
   data-toggle="tooltip" 
  title="The perspective of a person when looking at an optical device. This view is the extent that a camera sensor can pick up through electromagnetic radiation."
  ><img src="img/imp.png" /> Field Of View</a
>
</th>`;
  // * For Camera FPS Compare
  const cameraFPSContainer = document.querySelector("#js-cam-fps-container");
  cameraFPSContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
  <a

    class="tip"
    data-toggle="tooltip" 
  title="Frames per second. A numerical value that indicates how fast still images flicker for every second to create movement in videos."
    ><img src="img/imp.png" /> FPS</a
  >
</th>`;

  // * For Camera Deterrence Compare
  const cameraDrContainer = document.querySelector(
    "#js-cam-deterrence-container"
  );
  cameraDrContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
  <a

    class="tip"
    data-toggle="tooltip" 
  title="Active Deterrence cameras, with their bright LED spotlight and loud siren, are designed to stop people in their tracks."
    ><img src="img/imp.png" /> Active Deterrence</a
  >
</th>`;

  // * For Camera Color Night Vision Compare
  const cameraCnvContainer = document.querySelector("#js-cam-cnv-container");
  cameraCnvContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
  data-toggle="tooltip" 
  title="Color Night Vision allows the sensor to absorb more visible light, which allows the cameras to continue to provide color in low-light conditions."
  ><img src="img/imp.png" /> Color Night Vision</a
>
</th>`;

  // * For Camera Lens Type Compare

  const cameraLTypeContainer = document.querySelector(
    "#js-cam-ltype-container"
  );
  cameraLTypeContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
  <a

    class="tip"
    data-toggle="tooltip" 
  title="Fixed lens cameras have no optical zoom or options for adjustment (digital zoom might still be supported by the NVR and app).
  Motorized varifocal lens cameras are able to zoom in and out using their 4× optical zoom lenses."
    ><img src="img/imp.png" /> Lens Type</a
  >
</th>`;

  // * For Camera Color  Compare
  const cameraColorContainer = document.querySelector(
    "#js-cam-color-container"
  );
  cameraColorContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
  data-toggle="tooltip" 
  title="The camera's casing color."
  ><img src="img/imp.png" /> Color</a
>
</th>`;

  // * For Camera Camera Style Compare
  const cameraStyleContainer = document.querySelector(
    "#js-cam-style-container"
  );
  cameraStyleContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
<a
  class="tip"
  data-toggle="tooltip" 
  title="Dome cameras have circular, dome casing. Bullet cameras have cylindrical shape that looks like the shell of a bullet."
  ><img src="img/imp.png" /> Camera Style</a
>
</th>`;
  // * For Camera  Rating Compare
  const cameraIPratingContainer = document.querySelector(
    "#js-cam-iprating-container"
  );
  cameraIPratingContainer.innerHTML = `<th style="display: block" class="no-bot-bor">
  <a

    class="tip"
    data-toggle="tooltip" 
  title="Ingress Protection Rating. A numerical value assigned to an enclosed equipment to indicate its degree of protection from various outside forces. The first digit refers to intrusion protection while the second digit is about moisture protection."
    ><img src="img/imp.png" /> Environmental Rating</a
  >
</th>`;
};
/**
 * * Showing NVR Related Camera
 * @function ShowNvrRelatedCamera - Showing NVR Related Camera
 * @param {Object} cameraData - Json Data for NVR Related Camera Data
 * @param {Number} nvrSkuNum - NVR Sku umber
 */
const ShowNvrRelatedCamera = (cameraData, nvrSkuNum) => {
  // * Extracting Camera Data
  cameraData["item"].forEach((camera) => {
    if (nvrSkuNum === camera["sku"]) {
      // * Storeing NVR Related Camera Sku List Into Array
      // ! This Variable Store All NVR Related Camera Sku In One Index
      const nvrCapableCameraListArray = [];
      let recommendedCameraListArray = [];

      // * Push NVR Related Camera Sku List Into Array
      nvrCapableCameraListArray.push(camera["compatible_cameras"]);

      // * Push NVR Related Camera Recommanded SKU
      recommendedCameraListArray.push(camera["recommended_cameras"]);

      recommendedCameraList = recommendedCameraListArray.toString().split(",");
      //  console.log(recommendedCameraList);

      /**
       * * Creating NVR Capable Camera Sku List Into Array
       * * First Create Array with One Index Then Convert Into String then Break into Array
       */
      nvrCapableCameraList = nvrCapableCameraListArray.toString().split(",");
      // * Showing NVR Related Camera Template
      ShowNvrRelatedCameraTemplate(cameraData);
    }
  });
};

/**
 * * Show NVR In Product HighLight
 * @function nvrProductHightLight - Show NVR In Product HighLight
 * @param {Object} nvrData - Json Data For NVR
 */
const nvrProductHightLight = (nvrData) => {
  let discountPrice =
    nvrData["bundle_builder_price"] !== ""
      ? nvrData["sale_price"] - nvrData["bundle_builder_price"]
      : 0;
  // * Storing Selected NVR and Quantity, Quantity can be 'undefined'
  productSelectedList.push([
    nvrData["sku"],
    nvrQuantity === undefined ? 1 : nvrQuantity,
    discountPrice,
  ]);

  // * Showing In HTML
  productHighlight.innerHTML = `<div class="col-md-12 col-12 flexy no-jc">
  <div class="img-wrapper">
    <img
      src="${nvrData["image_link"]}"
      class="card-img-top"
      alt="${nvrData["title"]}"
    />
  </div>
  <div class="content">
    <h5 class="card-title">${nvrData["title"]}</h5>
    <p class="model">${nvrData["sku"]}</p>
    <p class="quantity">Qty - <span>${
      nvrQuantity === undefined ? 1 : nvrQuantity
    }</span></p>
  </div>
</div>`;
};

/**
 * * Next Button Step 2
 * @function nextBtnAction2 - Next Button Step 2
 * @param {Object} productDetails
 */
const nextBtnAction2 = (productDetails) => {
  // * When Click On Next Button and Step 2
  // ! It Use jQuery for Detect Step. Use JavaScript or ES6
  $(document).on("click", "#next[data-step=3]", function (e) {
    // * For Next Button Not Show in Compare
    // $(".next-step").removeClass("next-btn");
    // $(".pre-step").removeClass("pre-btn");
    // $("#next-arrow, #pre-arrow").removeClass("icon-arrow");

    if (productInfo[nvrSkuBtn].max_wifi == "") {
      $(".choose-iot").parent().addClass("d-none");
      $("#next[data-step=3]").trigger("click");
      e.preventDefault();
    } else {
      $(".choose-iot").parent().removeClass("d-none");
      $("#next-bundle").addClass("show-next-button");
    }

    if (addPocText > totalPoc) {
      e.preventDefault();
      // return;
    } else if (addPocText < totalPoc) {
      selectedCamera = productSelectedList.slice().splice(1);
      showSelectedCamera("#viewSelectedItem");

      currentStep = 3;
      if (currentStep != totalStep) {
        stepHTML.innerText = currentStep;
      } else {
        stepHTML.innerText = 3;
        return;
      }
      currentProgressBar(currentStep);
      // * Product Highlight Template

      // * Create Array Form IOT 'Data-iot' for Show All IOT Product
      iotproduct = $(".js-iot-tab[data-iot]")
        .map(function (_, el) {
          return $(el).data("iot");
        })
        .get();

      // * Create Array Form Accessories 'Data-accessories' for Show All Accessories Product
      accessoriesProduct = $(".js-accessories-tab[data-accessories]")
        .map(function (_, el) {
          return $(el).data("accessories");
        })
        .get();

      if (nvrSkuList.includes(nvrSkuBtn)) {
        productDetails["item"].forEach((item) => {
          if (item["sku"] === nvrSkuBtn) {
            const selectedNvr = $(".js-nvr-select-step2");
            const selectedNvr2 = $(".js-nvr-select-step3");
            let selectedNvrHTML = `<img src="${item["image_link"]}" />
              <div class="on-selection-detail">
                <h4>${item["title"]}</h4>
                <p>Qty - <span>${
                  nvrQuantity === undefined ? 1 : nvrQuantity
                }</span></p>
              </div>
              <div class="change js-change-recorder"  role="button">Edit</div>`;
            let selectedNvr2HTML = `<img src="${item["image_link"]}" />
              <div class="on-selection-detail">
                <h4>${item["title"]}</h4>
                <p>Qty - <span>${
                  nvrQuantity === undefined ? 1 : nvrQuantity
                }</span></p>
              </div>
              <div class="change js-change-recorder"  role="button">Edit</div>`;

            selectedNvr.html(selectedNvrHTML);
            selectedNvr2.html(selectedNvr2HTML);
          }
        });
      }

      // * Showing Selected Camera Count
      const chooseCamera = document.querySelector("#js-selected-cam-num1");
      const chooseCamera1 = document.querySelector("#js-choose-camera-count2");

      chooseCamera.innerText = cameraCount;
      chooseCamera1.innerText = cameraCount;

      // * Showing All IOT Product Based on it Type in Separate Tab Content
      allIotProduct(productDetails);
    }

    // * Showing Junction Box in Accessories Product

    // selectedCamList.forEach((camSkuEl) => {
    //   let jBox = productInfo[camSkuEl[0]]["compatible_junctionbox"].split(",");
    //   jBox.forEach((jBoxSku) => {
    //     showAccessories(jBoxSku, "#jBoxTemplate");
    //   });
    // });

    $("#previous-btn").attr("data-step", "3");
    // For Camera
    let MultiCam = 0;
    selectedCamera.forEach((e) => {
      MultiCam += e[1];
    });
    $(".cam-sel-status").text(MultiCam == 1 ? "Camera" : "Cameras");
  });

  $(document).on("click", "#next[data-step=4]", function () {
    // * For Next Button Not Show in Compare
    // $(".next-step").removeClass("next-btn");
    // $(".pre-step").removeClass("pre-btn");
    // $("#next-arrow, #pre-arrow").removeClass("icon-arrow");

    showSelectedIot();

    $("html,body").animate(
      {
        scrollTop: $("#js-accessories-scroll").offset().top,
      },
      "slow"
    );

    document.querySelector("#iot-count").innerText = iotCount;
    currentStep = 4;
    stepHTML.innerText = currentStep;

    currentProgressBar(currentStep);

    $("#previous-btn").attr("data-step", "3");
    document.querySelector("#summary-product").innerHTML = ``;
    summaryQty = 0;
    productSelectedList.forEach((summary) => {
      if (summary[1] !== 0) {
        summaryProduct(summary[0], summary[1]);
      }

      summaryQty += summary[1];
    });
    $(document).find("#qty-summary").text(summaryQty);
    // * Showing Sale Price In HTML With 2 Decimal Places
    document.querySelector("#summary-sale-price").innerHTML =
      summarySalePrice.toFixed(2);

    // * Showing MSRP Price In HTML With 2 Decimal Places
    // document.querySelector("#summary-price").innerHTML =
    //   summaryTotalPrice.toFixed(2);

    // * Showing Save Price In HTML With 2 Decimal Places
    document.querySelector("#summary-save").innerHTML = (
      summaryTotalPrice - summarySalePrice
    ).toFixed(2);

    // * Showing Save Percentage In HTML With 2 Decimal Places
    document.querySelector("#summary-discount").innerHTML =
      (
        ((summaryTotalPrice - summarySalePrice) / summaryTotalPrice) *
        100
      ).toFixed(2) + "%";

    $("#previous-btn").attr("data-step", "4");

    allAccessoriesProduct(productJson);

    // For IoT
    let MultiIot = 0;
    selectedIotList.forEach((e) => {
      MultiIot += e[1];
    });
    $(".iot-sel-status").text(MultiIot == 1||MultiIot == 0 ? "Item" : "Items");
  });
};
$(document).on("click", ".view-cart", function () {
  window.location.reload();
});

// * Showing Total Product Summary Page
const summaryProduct = (summary, qty) => {
  const SUMMARY_PRODUCT = document.querySelector("#summary-product");

  let summaryHtml = `
  <tr>
  <td>
    <div class="flexy">
      <img src="${productInfo[summary]["image_link"]}"
      alt="${productInfo[summary]["title"]}" />
      <div class="summary-content">
        <h3>${productInfo[summary]["title"]}</h3>
        <p class="features">${productInfo[summary]["sku"]}</p>
        <p class="price">$${Number(
          productInfo[summary]["bundle_builder_price"]
            ? productInfo[summary]["bundle_builder_price"]
            : productInfo[summary]["sale_price"]
        ).toFixed(2)}
        ${
          productInfo[summary]["bundle_builder_price"] != ""
            ? `<span class="msrp-price"><strike>$${Number(
                productInfo[summary]["sale_price"]
              ).toFixed(2)}</strike></span>
        </p>`
            : ""
        }
        
      </div>
    </div>
  </td>
  <td></td>
  <td>${qty}</td>
  <td>
    $${(
      parseInt(qty) *
      parseFloat(
        productInfo[summary]["bundle_builder_price"]
          ? productInfo[summary]["bundle_builder_price"]
          : productInfo[summary]["sale_price"]
      )
    ).toFixed(2)}
  </td>
</tr>

  `;

  SUMMARY_PRODUCT.insertAdjacentHTML("afterbegin", summaryHtml);
};

/**
 * * IOT Porduct Template
 * @function iotProductTemplate - IOT Porduct Template
 * @param {Object} IotProduct - Json Data For IOT Details
 * @param {String} iotProductTemplateId - Passing HTML ID for Showing in HTML
 */
const iotProductTemplate = (IotProduct, iotProductTemplateId) => {
  const iotTabTemplate = document.querySelector(iotProductTemplateId);
  iotTabTemplate.innerHTML += `
  <div class="col-md-3">
  <div class="card">
    <div class="img-wrapper">
    <!-- <span class="recom">Recommended</span> --->
      <a href="${
        IotProduct["link"]
      }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${`<img
        src="${IotProduct["image_link"]}"
        class="card-img-top"
        alt="${IotProduct["title"]}"
      />`}</a>
    
    </div>
    <div class="card-body">
      <h5 class="card-title">
      <a href="${
        IotProduct["link"]
      }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${
    IotProduct["title"]
  }</a>
      </h5>

      <ul class="features">
        <li>${IotProduct["sku"]}</li>
      </ul>
      <div
        class="yotpo bottomLine"
        data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
        data-domain="{{shop.permanent_domain | escape }}"
        data-product-id="{{ product.id }}"
        data-product-models="{{ product.id }}"
        data-name="{{ product.title | escape }}"
        data-url="{{ shop.url }}{{ product.url }}"
        data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
        data-description="{{ product.description | escape }}"
        data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}"
      ></div>
      <div
        class="yotpo bottomLine"
        data-product-id="{{ ${IotProduct["id"]} }}"
      ></div>
      <p class="price">
        $${Number(
          IotProduct["bundle_builder_price"]
            ? IotProduct["bundle_builder_price"]
            : IotProduct["sale_price"]
        ).toFixed(2)}
      </p>
      <a
        href="${IotProduct["link"]}"
        target="_blank"
        rel="noreferrer"
        class="text-decoration-none"
        >learn more</a
      >
      <div class="quantity buttons_added">
        <input
          type="button"
          value="-"
          class="minus js-iot-count-btn"
          data-sku="${IotProduct["sku"]}"
        />
        <input
          type="text"
          step="1"
          min="0"
          maxlength="2"
          name="quantity"
          value="1"
          title="Qty"
          class="input-text qty text js-iot-count-input"
          size="4"
          pattern="[0-9]*"
          inputmode="numeric"
          data-sku="${IotProduct["sku"]}"
          onkeypress="return validateNumber(event)"
        /><input
          type="button"
          value="+"
          class="plus js-iot-count-btn"
          data-sku="${IotProduct["sku"]}"
        />
      </div>
      <a
        href="javascript:void(0);"
        class="btn btn-primary js-iot-add-btn"
        data-sku="${IotProduct["sku"]}"
        >Add</a
      >
    </div>
  </div>
</div>
       `;
};

const accessoriesTemplate = (accessoriesProduct, accessoriesId) => {
  // * Checking Junction Box's Sku Are Available In Junction Box List

  // * Showing In HTML
  const accessoriesContainer = document.querySelector(accessoriesId);
  accessoriesContainer.innerHTML += `
    <div class="col-md-3">
    <div class="card">
        <div class="img-wrapper">
      
        <a href="${
          accessoriesProduct["link"]
        }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${`<img
          src="${accessoriesProduct["image_link"]}"
          class="card-img-top"
          alt="${accessoriesProduct["title"]}"
        />`}</a>
        </div>
        <div class="card-body">
        

          <h5 class="card-title">
          
          <a href="${
            accessoriesProduct["link"]
          }" target="_blank"  rel="noreferrer " class="text-decoration-none" style="display:block">${
    accessoriesProduct["title"]
  }</a></h5>
          
          <ul class="features">
            <li>${accessoriesProduct["sku"]}</li>
          </ul>
          <div class="yotpo bottomLine"
              data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
              data-domain="{{shop.permanent_domain | escape }}"
              data-product-id="{{ product.id }}"
              data-product-models="{{ product.id }}"
              data-name="{{ product.title | escape }}"
              data-url="{{ shop.url }}{{ product.url }}"
              data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
              data-description="{{ product.description | escape }}"
              data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
            </div>
            <div class="yotpo bottomLine"
              data-product-id="{{ ${accessoriesProduct["id"]} }}">
            </div>
          <p class="price">$${Number(
            accessoriesProduct["bundle_builder_price"]
              ? accessoriesProduct["bundle_builder_price"]
              : accessoriesProduct["sale_price"]
          ).toFixed(2)}</p>
		  <a href="${
        accessoriesProduct["link"]
      }" target="_blank"  rel="noreferrer" class="text-decoration-none" >learn more</a>
          <div class="quantity buttons_added">
            <input type="button" value="-" class="minus js-accessories-count-btn" data-sku="${
              accessoriesProduct["sku"]
            }"/><input
              type="text" maxlength="2"
              step="1"
              min="0"
              max="99"
              name="quantity"
              value="1"
              title="Qty"
              class="input-text qty text js-accessories-count-input"
              size="4"
              data-sku="${accessoriesProduct["sku"]}"
              pattern="[0-9]*" inputmode="numeric"
            /><input type="button" value="+" class="plus js-accessories-count-btn" data-sku="${
              accessoriesProduct["sku"]
            }" />
          </div>
          <a href="javascript:void(0);" class="btn btn-primary js-junction-box" data-sku="${
            accessoriesProduct["sku"]
          }"
            >Add</a
          >
        </div>
      </div>
      
      </div>`;
};

const showSelectedCamera = (htmlCamId) => {
  let selectCamId = htmlCamId;
  selectedCamList.forEach((camera) => {
    camera = camera.filter((item) => item !== 0);
    if (camera[1] !== undefined) {
      showSelectedProductTemplate(camera[0], camera[1], selectCamId);
    }
  });
};

const showSelectedIot = () => {
  let selectCamId = "#viewSelectedItemIot";
  selectedIotList.forEach((iot) => {
    iot = iot.filter((item) => item !== 0);
    if (iot[1] !== undefined) {
      showSelectedProductTemplate(iot[0], iot[1], selectCamId);
    }
  });
};

const showSelectedProductTemplate = (productData, productQuantity, htmlId) => {
  const selectedProductId = document.querySelector(htmlId);
  selectedProductId.innerHTML += ` 
  <div class="product-card">
                    <div class="card-body">
                      <div
                        class="row d-flex justify-content-between align-items-center"
                      >
                        <div class="col-md-2 col-lg-2 col-xl-2">
                          <img
                            src="${productInfo[productData]["image_link"]}"
                            class="img-fluid product-img"
                            alt="${productInfo[productData]["title"]}"
                          />
                        </div>
                        <div class="col-md-5 col-lg-6 col-xl-6">
                          <p class="lead fw-bold mb-2">
                          ${productInfo[productData]["title"]}
                          </p>
                          <p>
                            <span class="price">$${
                              productInfo[productData]["bundle_builder_price"]
                                ? productInfo[productData][
                                    "bundle_builder_price"
                                  ]
                                : productInfo[productData]["sale_price"]
                            } </span
                            >
                            ${
                              productInfo[productData]["poe_consumption"]
                                ? `<b class="fw-normal text-muted">|</b>
                            <span class="pro-wt">${productInfo[productData]["poe_consumption"]}W</span>`
                                : ``
                            }
                            
                          </p>
                        </div>
                        <div class="col-9 col-md-3 col-lg-3 col-xl-3 d-flex">
                          
                            <input
                              type="number"
                              step="1"
                              min="0"
                              max=""
                              name="quantity"
                              value="${productQuantity}"
                              title="Qty"
                              class="input-text qty text selected-product"
                              size="4"
                              pattern=""
                              inputmode="" style="pointer-events: none;"
                            />
                          </div>
                        </div>
                        
                      </div>
                    </div>
  `;
};

const allIotProduct = (productDetails) => {
  document.querySelector("#cameraTemplate").innerHTML = "";
  document.querySelector("#wifiCameraTemplate").innerHTML = "";
  document.querySelector("#doorTemplate").innerHTML = "";
  document.querySelector("#floodTemplate").innerHTML = "";
  document.querySelector("#sensorTemplate").innerHTML = "";

  iotproduct.forEach((iotName) => {
    productDetails["item"].forEach((iotItem) => {
      if (iotName === "Cameras" && iotName === iotItem["product_type_sub"]) {
        let id = "#cameraTemplate";
        iotProductTemplate(iotItem, id);
      }

      if (
        iotName === "Wi-Fi Security Cameras" &&
        iotName === iotItem["product_type_sub"]
      ) {
        let id = "#wifiCameraTemplate";
        iotProductTemplate(iotItem, id);
      }
      if (iotName === "Doorbells" && iotName === iotItem["product_type_sub"]) {
        let id = "#doorTemplate";
        iotProductTemplate(iotItem, id);
      }
      if (
        iotName === "Floodlights" &&
        iotName === iotItem["product_type_sub"]
      ) {
        let id = "#floodTemplate";
        iotProductTemplate(iotItem, id);
      }
      if (iotName === "Sensors" && iotName === iotItem["product_type_sub"]) {
        let id = "#sensorTemplate";
        iotProductTemplate(iotItem, id);
      }
    });
  });

  // * Show IoT if Available otherwise hide
  let allIot = [];
  let iotDomProduct = [
    "cameraTemplate",
    "wifiCameraTemplate",
    "doorTemplate",
    "floodTemplate",
    "sensorTemplate",
  ];

  /****** */
  let i = 0;
  iotproduct.forEach((item) => {
    allIot.push({
      navTitle: item,
      navChildLen: document.querySelector(`#${iotDomProduct[i]}`).children
        .length,
    });
    // allIot.push({
    //   navTitle: item,
    //   navChildLen: i % 2 !== 0 ? i : 0,
    // });
    i++;
  });

  allIot.forEach((el, key) => {
    if (el["navChildLen"] == 0) {
      $(document)
        .find(`.js-iot-tab[data-iot='${el["navTitle"]}']`)
        .parent()
        .hide();
      $(document)
        .find(`.js-iot-tab[data-iot='${el["navTitle"]}']`)
        .removeClass("active");

      $(document)
        .find(`.suggest-js-iot-tab`)
        .find(`[data-iot='${iotDomProduct[key]}']`)
        .addClass("active");

      $(document)
        .find(`.suggest-js-iot-tab`)
        .find(`#${iotDomProduct[key]}`)
        .parent()
        .hide();
    }
  });

  // * Show First List
  $(document).find("#myTab > li:visible:first").find("a").addClass("active");

  $(document)
    .find("#myTab ~ div:first")
    .find("div:visible:first")
    .addClass("active");

  let f_iot = $(document)
    .find("#myTab > li:visible:first")
    .find("a")
    .attr("href");

  $(document).find("#myTab ~ div").find(".tab-pane").removeClass("active show");

  $(document).find("#myTab ~ div").find(f_iot).addClass("active show");
};
const allAccessoriesProduct = (productDetails) => {
  document.querySelector("#cableTemplate").innerHTML = "";
  document.querySelector("#ledLightTemplate").innerHTML = "";
  document.querySelector("#otherTemplate").innerHTML = "";

  productDetails["item"].forEach((accessoriesItem) => {
    accessoriesProduct.forEach((accessoriesName) => {
      if (accessoriesItem["product_type"] === "Accessories") {
        if (
          accessoriesName === "Cables" &&
          accessoriesName === accessoriesItem["product_type_sub"]
        ) {
          let id = "#cableTemplate";
          accessoriesTemplate(accessoriesItem, id);
        }
        if (
          accessoriesName === "LED Light" &&
          accessoriesName === accessoriesItem["product_type_sub"]
        ) {
          let id = "#ledLightTemplate";
          accessoriesTemplate(accessoriesItem, id);
        }
      }
    });
    if (
      accessoriesItem["product_type"] === "Accessories" &&
      !accessoriesProduct.includes(accessoriesItem["product_type_sub"])
    ) {
      let id = "#otherTemplate";
      accessoriesTemplate(accessoriesItem, id);
    }
  });

  // * Show Accessories if Available otherwise hide
  showAccessoriesTab();
};

const showSelectedCam = (htmlCamId) => {
  let selectCamId = htmlCamId;
  selectedCamList.forEach((camera) => {
    camera = camera.filter((item) => item !== 0);
    if (camera[1] !== undefined) {
      showSelectedCamTemplate(camera[0], camera[1], selectCamId);
    }
  });
};
const clearShowSelectedCamTemplate = (htmlId) => {
  const selectedProductId = document.querySelector(htmlId);
  selectedProductId.innerHTML = "";
};
const showSelectedCamTemplate = (productData, productQuantity, htmlId) => {
  const selectedProductId = document.querySelector(htmlId);
  selectedProductId.innerHTML += ` 
  <div class="product-card">
                    <div class="card-body">
                      <div
                        class="row d-flex justify-content-between align-items-center"
                      >
                        <div class="col-md-2 col-lg-2 col-xl-2">
                          <img
                            src="${productInfo[productData]["image_link"]}"
                            class="img-fluid product-img"
                            alt="${productInfo[productData]["title"]}"
                          />
                        </div>
                        <div class="col-md-5 col-lg-6 col-xl-6">
                          <p class="lead fw-bold mb-2">
                          ${productInfo[productData]["title"]}
                          </p>
                          <p>
                            <span class="price">$${
                              productInfo[productData]["bundle_builder_price"]
                                ? productInfo[productData][
                                    "bundle_builder_price"
                                  ]
                                : productInfo[productData]["sale_price"]
                            } </span
                            >
                            ${
                              productInfo[productData]["poe_consumption"]
                                ? `<b class="fw-normal text-muted">|</b>
                            <span class="pro-wt">${productInfo[productData]["poe_consumption"]}W</span>`
                                : ``
                            }
                            
                          </p>
                        </div>
                        <div class="col-9 col-md-4 col-lg-4 col-xl-4 d-flex">
                          
                            <input
                              type="number"
                              step="1"
                              min="0"
                              max=""
                              name="quantity"
                              value="${productQuantity}"
                              title="Qty"
                              class="input-text qty text selected-product"
                              size="4"
                              pattern=""
                              inputmode="" style="pointer-events: none;"/>
                            <span class="pro-wt align-self-center fw-bold">x&nbsp;</span>
                            <span class="pro-wt align-self-center fw-bold">${
                              productInfo[productData]["poe_consumption"]
                            }W</span>
                            <span class="pro-wt align-self-center fw-bold">&nbsp;=&nbsp;</span>

                            <span class="pro-wt align-self-center fw-bold total-cam-poc">${(
                              productInfo[productData]["poe_consumption"] *
                              productQuantity
                            ).toFixed(2)}W</span>
                          </div>
                        </div>
                        
                      </div>
                    </div>
  `;
};

// * Validate For Input Number

function validateNumber(e) {
  const pattern = /^[0-9]$/;

  return pattern.test(e.key);
}

const showAccessoriesTab = () => {
  let allAcc = [];
  let AccDomProduct = [
    "hardDriveTemplate",
    "cableTemplate",
    "ledLightTemplate",
    "jBoxTemplate",
    "otherTemplate",
  ];
  let i = 0;
  accessoriesProduct.forEach((item) => {
    allAcc.push({
      navTitle: item,
      navChildLen: document.querySelector(`#${AccDomProduct[i]}`).children
        .length,
    });
    // allAcc.push({
    //   navTitle: item,
    //   navChildLen: i % 2 !== 0 ? i : 0,
    // });
    i++;
  });

  allAcc.forEach((el, key) => {
    if (el["navChildLen"] == 0) {
      $(document)
        .find(`.js-accessories-tab[data-accessories='${el["navTitle"]}']`)
        .parent()
        .hide();
      $(document).find(`.js-accessories-tab`).removeClass("active");

      $(document)
        .find(`.suggest-js-accessories-tab`)
        .find(`[data-accessories='${AccDomProduct[key]}']`)
        .addClass("active");

      $(document)
        .find(`.suggest-js-accessories-tab`)
        .find(`#${AccDomProduct[key]}`)
        .parent()
        .hide();
    }
  });

  // * Show First List
  $(document).find("#myTab2 > li:visible:first").find("a").addClass("active");

  $(document)
    .find("#myTab2 ~ div:first")
    .find("div:visible:first")
    .addClass("active");

  let f_acc = $(document)
    .find("#myTab2 > li:visible:first")
    .find("a")
    .attr("href");

  $(document)
    .find("#myTab2 ~ div")
    .find(".tab-pane")
    .removeClass("active show");

  $(document).find("#myTab2 ~ div").find(f_acc).addClass("active show");
};

const mobileCartNumber = () => {
  let totalSum = 0;
  productSelectedList.forEach((products) => {
    $("#js-total-product-count").html(0);

    totalSum += products[1];
  });
  $("#js-total-product-count").html(totalSum);
};
