// ! Using Javascript Strict Mode
("use strict");
/**
 * * Global Variable
 */
let nvrQuantity; // * NVR Quantity
let cameraCount = 0; // * Default Camera Count
let maxCameraSelect = 0; // * Max Camera Selected
let maxIotSelect = 2; // * Max IOT Selected
let cameraQuantity = 1; // * Default Camera Quantity
let junctionBoxQuantity = 1; // * Default Junction Box Quantity
let iotQuantity = 1; // * Default IOT Quantity
let iotCount = 0; // * Default IOT Count
let productJson = [];
let selectedCamJBox = [];
let tempSelectedCamJBox = [];
let existjBoxSku = [];
let jBoxValue = [];
let jBoxValue2 = [];
let jBox = [];
let tempJBoxCamSku = [];
let JBoxCamSku = [];
var camElement = {};
let compareNvrSku = [];
let compareCamSku = [];
let activeJBoxSkuList = [];

let cJunctionBox = [];
let camCompareCount = 0;
// // * Total Sale Price
let summaryTotalPrice = 0;

// * Total MSRP (Manufacturer's Suggested Retail Price) Price
let summarySalePrice = 0;
let maxHDDCount = 0;
let hddCheck = 0;
let maxHDDSelect = 0;
let summaryQty = 0;
let shopifyProduct = {
  draft_order: {
    line_items: [],
  },
};

/**
 * * This Store All Selected Product
 * ! This Is Store Temporary Value Of Product. It Used For Show Not Product List and Not Used For Further Used
 *  @type {Array}
 */
let productSelectedList = [];
// * Store Sku Based Product List
let productInfo = [];

// * Access HTML
const productHighlight = document.querySelector("#js-product-highlight"); // * Product Highlight HTML
const addPoc = document.querySelector("#js-poc-add"); // * Power Of Consumption
let addPocText = document.querySelector("#js-poc-add").innerText; // * Power Of Consumption HTML Text
$("#js-poc-color").parent().addClass("d-none");
/**
 * * Creating Fetch Request Using Fetch Api
 * @function jsonProductData - Getting JSON Data
 * @Return
 */
const jsonProductData = async () => {
  // * Getting XML Data
  const response = await fetch("./main_xml_us.php");

  // * Checking Response
  if (!response.ok) {
    const message = `An error has occurred: ${response.status}`;
    new Error(message);
  }

  const data = await response.text(); //* Getting Text Data instead of XML

  // * Return XML Data
  const parser = new DOMParser();
  /**
   * ! Give 'XML Parsing Error: syntax error' In  //console
   * TODO: Fix XML Parsing Error
   */

  const xmlData = parser.parseFromString(data, "application/xml"); //* Changing Text into XML
  const xmlChildData = xmlData.childNodes[0].innerHTML;

  // * Converting XML into JSON
  const x2js = new X2JS();
  const jsonConvert = x2js.xml_str2json(xmlChildData);

  // * Return Json Data
  const jsonData = jsonConvert["channel"];

  for (var i = 0; i < jsonData["item"].length; i++) {
    productInfo[jsonData["item"][i].sku] = jsonData["item"][i];
  }
  for (var i = 0; i < jsonData["item"].length; i++) {
    productJson = jsonData;
  }

  // * Showing NVR List
  nvrProduct(jsonData);

  // * Getting NVR Sku When Click On NVR Add Button
  GetNvrSku(jsonData);

  // * Next Button Function Calling
  nextBtnAction(jsonData);

  // * Next Button Step 2
  nextBtnAction2(jsonData);
};

// * Calling Json Function
jsonProductData().then((xmlData) => xmlData);

/**
 * * Product Highlight Template
 * @function productHighlightTemplate - Product Highlight Template
 */
const productHighlightTemplate = () => {
  // * Clear Previous Product HTML Template
  productHighlight.innerHTML = "";

  // * Extract Product From Product Selected List
  productSelectedList.forEach((product) => {
    if (product[1] != 0) {
      const productHighlightHTML = `<div class="col-md-12 col-12 flexy no-jc">
          <div class="img-wrapper">
            <img
              src="${productInfo[product[0]]["image_link"]}"
              class="card-img-top"
              alt="${productInfo[product[0]]["title"]}"
            />
          </div>
          <div class="content">
            <h5 class="card-title">${productInfo[product[0]]["title"]}</h5>
            <p class="model">${productInfo[product[0]]["sku"]}</p>
            <p class="quantity">Qty - <span>${product[1]}</span></p>
          </div>
        </div>`;

      // * Show in HTML
      productHighlight.insertAdjacentHTML("beforeend", productHighlightHTML);
    }
  });
};

/**
 * * Update Product List When Click On Plus/Minus Button
 * @function productHighlightQuantity - Product Highlight Quantity
 */
const updateProductQuantity = () => {
  productSelectedList.forEach((item) => {
    item.filter((i) => {
      if (i == $(this).attr("data-sku")) {
        if (item !== -1) {
          productSelectedList[productSelectedList.indexOf(item)] = [
            productSelectedList[productSelectedList.indexOf(item)][0],
            parseInt($(this).siblings(".qty").val()),
          ];
        }
      }
    });
  });
};

/**
 * * Calculating Product Price
 * @function productHighlightPrice - Calculating Product Price
 */
const productHighlightPrice = () => {
  // * Extract Product From Product Selected List
  let totalSalePrice = 0;

  // // * Total MSRP (Manufacturer's Suggested Retail Price) Price
  let totalPrice = 0;
  productSelectedList.forEach((item) => {
    // * Calculating Total Sale Price Without Comma
    totalSalePrice +=
      (productInfo[item[0]]["bundle_builder_price"]
        ? parseFloat(
            productInfo[item[0]]["bundle_builder_price"].replace(/,/g, "")
          )
        : parseFloat(productInfo[item[0]]["sale_price"].replace(/,/g, ""))) *
      item[1];

    // * Calculating Total MSRP Price Without Comma
    // * Checking If MSRP Available, If MSRP Not it Used Sale Price
    totalPrice +=
      (productInfo[item[0]]["sale_price"]
        ? parseFloat(productInfo[item[0]]["sale_price"].replace(/,/g, ""))
        : parseFloat(
            productInfo[item[0]]["bundle_builder_price"].replace(/,/g, "")
          )) * item[1];
  });

  // * Showing Sale Price In HTML With 2 Decimal Places
  document.querySelector("#js-total-sale-price").innerHTML =
    "$" + totalSalePrice.toFixed(2);

  // * Showing MSRP Price In HTML With 2 Decimal Places
  document.querySelector("#js-total-price").innerHTML =
    "$" + totalPrice.toFixed(2);

  // * Showing Save Price In HTML With 2 Decimal Places
  document.querySelector("#js-save-price").innerHTML =
    "$" + (totalPrice - totalSalePrice).toFixed(2);

  // * Showing Save Percentage In HTML With 2 Decimal Places
  document.querySelector("#js-save-pct").innerHTML =
    (((totalPrice - totalSalePrice) / totalPrice) * 100).toFixed(2) + "%";

  if (totalPrice == totalSalePrice) {
    $("#js-total-price").hide();
  } else {
    $("#js-total-price").show();
  }
  summaryTotalPrice = totalPrice;
  summarySalePrice = totalSalePrice;
};

const productResetHighlightPrice = () => {
  // * Total Sale Price
  let totalSalePrice = 0;

  // * Total MSRP (Manufacturer's Suggested Retail Price) Price
  let totalPrice = 0;
  // * Extract Product From Product Selected List
  productSelectedList = [];
};

const productCamHighlightPrice = () => {
  // * Total Sale Price
  let totalSalePrice = 0;

  // * Total MSRP (Manufacturer's Suggested Retail Price) Price
  let totalPrice = 0;
  // * Extract Product From Product Selected List
  // productSelectedList = [];

  // * Extract Product From Product Selected List
  productSelectedList.forEach((item) => {
    // * Calculating Total Sale Price Without Comma
    totalSalePrice +=
      (productInfo[item[0]]["bundle_builder_price"]
        ? parseFloat(productInfo[item[0]]["bundle_builder_price"])
        : parseFloat(productInfo[item[0]]["sale_price"].replace(/,/g, ""))) *
      item[1];

    // * Calculating Total MSRP Price Without Comma
    // * Checking If MSRP Available, If MSRP Not it Used Sale Price
    totalPrice +=
      (productInfo[item[0]]["bundle_builder_price"]
        ? parseFloat(productInfo[item[0]]["bundle_builder_price"])
        : parseFloat(productInfo[item[0]]["sale_price"].replace(/,/g, ""))) *
      item[1];
  });

  // * Showing Sale Price In HTML With 2 Decimal Places
  document.querySelector("#js-total-sale-price").innerHTML =
    totalSalePrice.toFixed(2);

  // * Showing MSRP Price In HTML With 2 Decimal Places
  document.querySelector("#js-total-price").innerHTML = totalPrice.toFixed(2);

  // * Showing Save Price In HTML With 2 Decimal Places
  document.querySelector("#js-save-price").innerHTML = (
    totalPrice - totalSalePrice
  ).toFixed(2);

  // * Showing Save Percentage In HTML With 2 Decimal Places
  document.querySelector("#js-save-pct").innerHTML =
    (((totalPrice - totalSalePrice) / totalPrice) * 100).toFixed(2) + "%";
};
/**
 * * Incrementing Camera Quantity When Click On Add Button
 */

$(document).on("click", ".js-camera-add-btn", function () {
  /**
   * * Check If Camera Count (When Click On Add Button) Smaller Then Total Camera Count If Condition Is False Then Stop Increment In Camera Count
   */
  if (cameraCount < totalCapableCamCount) {
    $("#next").attr("disabled", false);

    $(this).parents("td").addClass("active");
    // * Showing Add and Count Button
    jQuery(this).siblings(".quantity").css("display", "block");
    jQuery(this).hide();

    // * Increment Camera Count
    cameraCount++;

    if (cameraCount >= totalCapableCamCount) {
      $(".js-camera-add-btn").addClass("btn-secondary");
    }

    // $("#js-j-box-title").css("display", "block");

    // * Show In HTML Camera Count
    document.querySelector("#js-camera-count").innerText = cameraCount;
    /**
     * * Adding Power Of Consumption In HTML
     * Only Two Decimal Number Allowed
     */
    addPocText = parseFloat(addPocText) + parseFloat($(this).attr("data-poc"));
    addPoc.innerText = addPocText.toFixed(2);

    if (parseInt(addPocText) > parseInt(totalPoc)) {
      $("#js-poc-color").parent().removeClass("d-none");
      $("#js-poc-color").css("color", "#f00");
    } else {
      $("#js-poc-color").css("color", "#219653");
    }
    let discountPrice =
      productInfo[$(this).attr("data-sku")]["bundle_builder_price"] !== ""
        ? productInfo[$(this).attr("data-sku")]["sale_price"] -
          productInfo[$(this).attr("data-sku")]["bundle_builder_price"]
        : 0;

    // * Adding Product In List with Sku and Camera Quantity
    productSelectedList.push([
      $(this).attr("data-sku"),
      cameraQuantity,
      discountPrice,
    ]);
    console.log(productSelectedList, discountPrice);
    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
    $(".next-step").addClass("show-next-button");

    selectedCamList.push([
      $(this).attr("data-sku"),
      cameraQuantity,
      discountPrice,
    ]);
    selectedCamerasList[$(this).attr("data-sku")] = cameraQuantity;
    $("#js-total-product-count").html(productSelectedList.length);

    cJunctionBox.push(
      productInfo[$(this).attr("data-sku")]["compatible_junctionbox"]
        .toString()
        .split(",")
    );

    let currentJBox = productInfo[$(this).attr("data-sku")][
      "compatible_junctionbox"
    ]
      .toString()
      .split(",");

    $(currentJBox).each(function (k, v) {
      if (jQuery.inArray(v, cJunctionBox) == -1) {
        cJunctionBox.push(v);
      }
    });

    tempSelectedCamJBox.push(
      productInfo[$(this).attr("data-sku")]["compatible_junctionbox"]
    );

    // document.querySelector("#js-poc-color").style.color = "#219653";
    // document.querySelector("#js-poc-color").style.color = "#219653";

    // // con;
    let thisSku = $(this).data("sku");
    tempJBoxCamSku.push(
      productInfo[$(this).attr("data-sku")]["compatible_junctionbox"]
    );
    JBoxCamSku = tempJBoxCamSku.toString().split(",");
    camElement.sku = $(this).attr("data-sku");

    jBoxValue = productInfo[thisSku].compatible_junctionbox.split(",");

    let junctionElement = $("#jBoxTemplate").find(".card");
    let jElementArray = [];

    if (junctionElement.length > 0) {
      $.each(junctionElement, function (key, val) {
        jElementArray.push($(val).data("sku"));

        let tmp_v = $(val).data("sku");
        if (jQuery.inArray(tmp_v, jBoxValue) != -1) {
          jBoxValue.push(tmp_v);
          jBox.push(tmp_v);
        }
      });
    } else {
      jBox = jBoxValue;
    }
    jBoxValue.forEach((item) => {
      if (jQuery.inArray(item, jElementArray) === -1) {
        junctionBoxTemplate(item);
      }
    });

    selectedCamJBox = tempSelectedCamJBox.toString().split(",");
    selectedCamJBox.forEach((item) => {
      if (allJBox.includes(item)) {
        junctionBoxTemplate();
      }
    });
  }
});

/**
 *  * Increment / Decrement Camera Quantity When Click On Plus / Minus Button
 */
$(document).on("click", ".js-camera-count-btn", function () {
  // * Getting Plus Icon Number
  let a = jQuery(this).closest(".quantity").find(".qty");

  // * Check If Minus Class Available
  if ($(this).hasClass("minus")) {
    // * Check If Camera Count and Plus Icon Value Greater Then 0
    if (cameraCount > 0 && a.val() > 0) {
      // * Decrement Camera Count
      cameraCount--;
      if (cameraCount == 0) {
        document.querySelector("#js-poc-color").style.color = "#000";
        $(".next-step").removeClass("show-next-button");
        $("#next").attr("disabled", true);

        // $("#js-j-box-title").css("display", "none");
      }

      // * Show In HTML Camera Count
      document.querySelector("#js-camera-count").innerText = cameraCount;

      // * Decrement
      a.val(parseFloat(a.val()) - 1);

      if (cameraCount < totalCapableCamCount) {
        $(".js-camera-add-btn").removeClass("btn-secondary");
      }

      // * Increment Max Camera Value So That Max Camera Selection Can Decrease
      maxCameraSelect++;

      // * Decrease Power Of Consumption In HTML
      addPocText =
        parseFloat(addPocText) - parseFloat($(this).attr("data-poc"));
      addPoc.innerText = addPocText.toFixed(2);

      if (parseInt(addPocText) > parseInt(totalPoc)) {
        $("#js-poc-color").parent().removeClass("d-none");
        $("#js-poc-color").css("color", "#f00");
      } else {
        $("#js-poc-color").css("color", "#219653");
      }

      // * Checking If Product List Is Empty
      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update Camera Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        // * Update Product List When Click On Plus/Minus Button
        // ! Function Is Not Working. It Not Throw Any Error But It Not Update Product List
        // TODO : Fix This Issue
        // updateProductQuantity();
      }
      selectedCamList.forEach((item) => {
        item.filter((i) => {
          if (i == $(this).attr("data-sku")) {
            selectedCamList[selectedCamList.indexOf(item)] = [
              selectedCamList[selectedCamList.indexOf(item)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });

      selectedCamerasList[$(this).attr("data-sku")] = $(this)
        .siblings(".qty")
        .val();
      let totalSum = 0;
      productSelectedList.forEach((products) => {
        $("#js-total-product-count").html(0);

        totalSum += products[1];
      });
      $("#js-total-product-count").html(totalSum);

      if (a.val() == 0) {
        $(this).parents("td").removeClass("active");
        let thisSku = $(this).data("sku");
        let tempJBoxMinus = [];
        let jBoxValueMinus =
          productInfo[thisSku].compatible_junctionbox.split(",");

        let activeJBoxSku = $("#js-nvr-related-cam").children(".active");

        $.each(activeJBoxSku, function (key, val) {
          tempJBoxMinus.push(
            productInfo[val.dataset.sku].compatible_junctionbox
          );
        });
        activeJBoxSkuList = tempJBoxMinus.toString().split(",");

        let currentJBox = productInfo[$(this).attr("data-sku")][
          "compatible_junctionbox"
        ]
          .toString()
          .split(",");

        $(currentJBox).each(function (k, v) {
          if (activeJBoxSkuList.indexOf(v) == -1) {
            $(`.card[data-sku=${v}]`).parent().remove();
            productSelectedList.forEach((items) => {
              items.forEach((item) => {
                if (item == v) {
                  productSelectedList[productSelectedList.indexOf(items)] = [
                    productSelectedList[productSelectedList.indexOf(items)][0],
                    0,
                  ];
                }
              });
            });
          }
          if (cJunctionBox.indexOf(v) !== -1) {
            let pos = cJunctionBox.indexOf(v);
            cJunctionBox.splice(pos, 1);
          }
        });
        // activeJBoxSkuList.forEach((item) => {
        //   if (JBoxCamSku.includes(item)) {
        //     $(`.card[data-sku=${item}]`).html("");
        //   } else {
        //   }
        // });

        // let tempJBoxMinus = [];
        // let junctionElement = $("#js-j-box-container").children(".card");
        // if (junctionElement.length > 0) {
        //   $.each(junctionElement, function (key, val) {
        //     tempJBoxMinus.push(val.dataset.sku);
        //     tempSku = val.dataset.sku;
        //   });
        //   tempJBoxMinus = tempJBoxMinus.filter(
        //     (val) => !jBoxValueMinus.includes(val)
        //   );
        //   delJunctionBoxTemplate();
        //   if (tempJBoxMinus.length == 0) {
        //     delJunctionBoxTemplate();
        //   } else {
        //     tempJBoxMinus.forEach((item) => {
        //       junctionBoxTemplate(item);
        //       if (jBoxValueMinus.includes(item)) {
        //       }
        //     });
        //   }
        // } else {
        //   jBox = jBoxValue;
        // }
      }

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();
      return false;
    }
    // if (a.val() == 0) {
    //   $(this).parents("td").removeClass("active");
    // }
    // * Check If Minus Class Available
  } else if ($(this).hasClass("plus")) {
    /**
     * * Check If Camera Count (When Click On Add Button) Smaller Then Total Camera Count If Condition Is False Then Stop Increment In Camera Count
     */
    if (cameraCount < totalCapableCamCount) {
      $("#next").attr("disabled", false);

      $(".next-step").addClass("show-next-button");

      $(this).parents("td").addClass("active");
      // * Decrement Max Camera Value So That Max Camera Selection Can Increase
      maxCameraSelect--;

      // $("#js-j-box-title").css("display", "block");

      // * Increase Camera Count
      cameraCount++;
      document.querySelector("#js-poc-color").style.color = "#219653";
      // * Show In HTML Camera Count
      document.querySelector("#js-camera-count").innerText = cameraCount;

      a.val(parseFloat(a.val()) + 1);

      if (maxCameraSelect <= 0) {
        maxCameraSelect = 0;
      }

      if (cameraCount >= totalCapableCamCount) {
        $(".js-camera-add-btn").addClass("btn-secondary");
      }
      /**
       * * Adding Power Of Consumption In HTML
       * Only Two Decimal Number Allowed
       */
      addPocText =
        parseFloat(addPocText) + parseFloat($(this).attr("data-poc"));
      addPoc.innerText = addPocText.toFixed(2);

      if (parseInt(addPocText) > parseInt(totalPoc)) {
        $("#js-poc-color").parent().removeClass("d-none");
        $("#js-poc-color").css("color", "#f00");
      } else {
        $("#js-poc-color").css("color", "#219653");
      }

      // * Checking If Product List Is Empty
      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update Camera Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        selectedCamerasList[$(this).attr("data-sku")] = $(this)
          .siblings(".qty")
          .val();

        let totalSum = 0;
        productSelectedList.forEach((products) => {
          $("#js-total-product-count").html(0);

          totalSum += products[1];
        });
        $("#js-total-product-count").html(totalSum);
      }

      // if (a.val() == 1) {
      //   // * Product Highlight Template
      //   productHighlightTemplate();

      //   // * Calculating Product Price
      //   productHighlightPrice();
      // }

      selectedCamList.forEach((item) => {
        item.filter((i) => {
          if (i == $(this).attr("data-sku")) {
            if (item !== -1) {
              selectedCamList[selectedCamList.indexOf(item)] = [
                selectedCamList[selectedCamList.indexOf(item)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          }
        });
      });

      tempSelectedCamJBox.push(
        productInfo[$(this).attr("data-sku")]["compatible_junctionbox"]
      );

      let thisSku = $(this).data("sku");
      jBoxValue = productInfo[thisSku].compatible_junctionbox.split(",");

      let junctionElement = $("#jBoxTemplate").find(".card");
      let jElementArray = [];

      if (junctionElement.length > 0) {
        $.each(junctionElement, function (key, val) {
          // existjBoxSku.push(val[key].data("sku"));
          jElementArray.push($(val).data("sku"));
          let tmp_v = $(val).data("sku");
          if (jQuery.inArray(tmp_v, jBoxValue) != -1) {
            jBoxValue.push(tmp_v);
            jBox.push(tmp_v);
          }
        });
      } else {
        jBox = jBoxValue;
      }

      jBoxValue.forEach((item) => {
        if (jQuery.inArray(item, jElementArray) === -1) {
          junctionBoxTemplate(item);
        }
      });

      selectedCamJBox = tempSelectedCamJBox.toString().split(",");
      selectedCamJBox.forEach((item) => {
        if (allJBox.includes(item)) {
          junctionBoxTemplate();
        }
      });

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();
      return false;
    }
  }
});

// * For HDD
$(document).on("click", ".js-hdd-count-btn", function () {
  // * Getting Plus Icon Number
  let a = jQuery(this).closest(".quantity").find(".qty");

  // * Check If Minus Class Available
  if ($(this).hasClass("minus")) {
    // * Check If HDD Count and Plus Icon Value Greater Then 0
    if (maxHDDCount > 0 && a.val() > 0) {
      // * Decrement HDD Count
      maxHDDCount--;

      // * Decrement
      a.val(parseFloat(a.val()) - 1);

      // if (maxHDDCount < productInfo[nvrSkuBtn]["hdd_bays"]) {
      //   $(".js-hard-disk").removeClass("btn-secondary");
      // }

      // // * Increment Max HDD Value So That Max HDD Selection Can Decrease
      // maxHDDSelect++;

      // * Checking If Product List Is Empty
      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update HDD Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and HDD Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        // * Update Product List When Click On Plus/Minus Button
        // ! Function Is Not Working. It Not Throw Any Error But It Not Update Product List
        // TODO : Fix This Issue
        // updateProductQuantity();
      }

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();
      return false;
    }

    // * Check If Minus Class Available
  } else if ($(this).hasClass("plus")) {
    /**
     * * Check If HDD Count (When Click On Add Button) Smaller Then Total HDD Count If Condition Is False Then Stop Increment In HDD Count
     */

    // // * Decrement Max HDD Value So That Max HDD Selection Can Increase
    // maxHDDSelect--;

    // * Increase HDD Count
    maxHDDCount++;

    a.val(parseFloat(a.val()) + 1);

    // if (maxHDDSelect <= 0) {
    //   maxHDDSelect = 0;
    // }

    // if (maxHDDCount >= productInfo[nvrSkuBtn]["hdd_bays"]) {
    //   $(".js-hard-disk").addClass("btn-secondary");
    // }
    // * Checking If Product List Is Empty
    if (productSelectedList.length !== 0) {
      // * Extracting Product From Product Selected List
      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.filter((sku) => {
          if (sku == $(this).attr("data-sku")) {
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });
    }

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
    return false;
  }
});
function wcqib_refresh_quantity_increments() {
  jQuery(
    "div.quantity:not(.buttons_added), td.quantity:not(.buttons_added)"
  ).each(function (a, b) {
    var c = jQuery(b);
    c.addClass("buttons_added"),
      c
        .children()
        .first()
        .before('<input type="button" value="-" class="minus" />'),
      c
        .children()
        .last()
        .after('<input type="button" value="+" class="plus" />');
  });
}
String.prototype.getDecimals ||
  (String.prototype.getDecimals = function () {
    var a = this,
      b = ("" + a).match(/(?:\.(\d+))?(?:[eE]([+-]?\d+))?$/);
    return b ? Math.max(0, (b[1] ? b[1].length : 0) - (b[2] ? +b[2] : 0)) : 0;
  }),
  jQuery(document).ready(function () {
    wcqib_refresh_quantity_increments();
  }),
  jQuery(document).on("updated_wc_div", function () {
    wcqib_refresh_quantity_increments();
  });

jQuery(document).on(
  "click",
  "#js-nvr-product .plus, #js-nvr-product .minus",
  function () {
    var a = jQuery(this).closest(".quantity").find(".qty"),
      b = parseFloat(a.val()),
      c = parseFloat(a.attr("max")),
      d = parseFloat(a.attr("min")),
      e = a.attr("step");
    (b && "" !== b && "NaN" !== b) || (b = 0),
      ("" !== c && "NaN" !== c) || (c = ""),
      ("" !== d && "NaN" !== d) || (d = 0),
      ("any" !== e && "" !== e && void 0 !== e && "NaN" !== parseFloat(e)) ||
        (e = 1),
      jQuery(this).is(".plus")
        ? c && b >= c
          ? a.val(c)
          : a.val((b + parseFloat(e)).toFixed(e.getDecimals()))
        : d && b <= d
        ? a.val(d)
        : b > 0 && a.val((b - parseFloat(e)).toFixed(e.getDecimals())),
      a.trigger("change");
    nvrQuantity = a.val();
  }
);

// * Working Junction Box Click Event
$(document).on("click", ".js-junction-box", function () {
  let discountPrice =
    productInfo[$(this).attr("data-sku")]["bundle_builder_price"] !== ""
      ? productInfo[$(this).attr("data-sku")]["sale_price"] -
        productInfo[$(this).attr("data-sku")]["bundle_builder_price"]
      : 0;

  // * Adding Product In List with Sku and Junction Box Quantity
  productSelectedList.push([
    $(this).attr("data-sku"),
    junctionBoxQuantity,
    discountPrice,
  ]);

  let totalSum = 0;
  productSelectedList.forEach((products) => {
    $("#js-total-product-count").html(0);

    totalSum += products[1];
  });
  $("#js-total-product-count").html(totalSum);

  // * Product Highlight Template
  productHighlightTemplate();

  // * Calculating Product Price
  productHighlightPrice();
});

// * Working Hard Disk Click Event
$(document).on("click", ".js-hard-disk", function () {
  let discountPrice =
    productInfo[$(this).attr("data-sku")]["bundle_builder_price"] !== ""
      ? productInfo[$(this).attr("data-sku")]["sale_price"] -
        productInfo[$(this).attr("data-sku")]["bundle_builder_price"]
      : 0;

  jQuery(this).siblings(".quantity").css("display", "block");
  jQuery(this).hide();
  maxHDDCount++;
  // * Adding Product In List with Sku and Junction Box Quantity
  productSelectedList.push([$(this).attr("data-sku"), 1, discountPrice]);

  let totalSum = 0;
  productSelectedList.forEach((products) => {
    $("#js-total-product-count").html(0);

    totalSum += products[1];
  });
  $("#js-total-product-count").html(totalSum);

  // * Product Highlight Template
  productHighlightTemplate();

  // * Calculating Product Price
  productHighlightPrice();
});

$(document).on("click", "input.js-j-box-count-btn", function () {
  let a = jQuery(this).closest(".quantity").find(".qty");

  // * Check If Minus Class Available
  if ($(this).hasClass("minus")) {
    // * Check If Camera Count and Plus Icon Value Greater Then 0
    if (a.val() > 0) {
      a.val(parseFloat(a.val()) - 1);
      // * Checking If Product List Is Empty
      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update Camera Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        let totalSum = 0;
        productSelectedList.forEach((products) => {
          $("#js-total-product-count").html(0);

          totalSum += products[1];
        });
        $("#js-total-product-count").html(totalSum);
      }

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();

      return false;
    }

    // * Check If Minus Class Available
  } else if ($(this).hasClass("plus")) {
    a.val(parseFloat(a.val()) + 1);
    // * Checking If Product List Is Empty
    if (productSelectedList.length !== 0) {
      // * Extracting Product From Product Selected List
      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.filter((sku) => {
          if (sku == $(this).attr("data-sku")) {
            // * Update Camera Quantity In Index Of Previously Selected Product
            /**
             * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
             * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
             */
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });

      let totalSum = 0;
      productSelectedList.forEach((products) => {
        $("#js-total-product-count").html(0);

        totalSum += products[1];
      });
      $("#js-total-product-count").html(totalSum);
    }

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  }
});

$(document).on("click", "input.js-accessories-count-btn", function () {
  let a = jQuery(this).closest(".quantity").find(".qty");

  // * Check If Minus Class Available
  if ($(this).hasClass("minus")) {
    // * Check If Camera Count and Plus Icon Value Greater Then 0
    if (a.val() > 0) {
      a.val(parseFloat(a.val()) - 1);
      // * Checking If Product List Is Empty
      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update Camera Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        let totalSum = 0;
        productSelectedList.forEach((products) => {
          $("#js-total-product-count").html(0);

          totalSum += products[1];
        });
        $("#js-total-product-count").html(totalSum);
      }

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();

      return false;
    }

    // * Check If Minus Class Available
  } else if ($(this).hasClass("plus")) {
    a.val(parseFloat(a.val()) + 1);
    // * Checking If Product List Is Empty
    if (productSelectedList.length !== 0) {
      // * Extracting Product From Product Selected List
      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.filter((sku) => {
          if (sku == $(this).attr("data-sku")) {
            // * Update Camera Quantity In Index Of Previously Selected Product
            /**
             * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
             * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
             */
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });

      let totalSum = 0;
      productSelectedList.forEach((products) => {
        $("#js-total-product-count").html(0);

        totalSum += products[1];
      });
      $("#js-total-product-count").html(totalSum);
    }

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  }
});

$(document).on("click", ".js-iot-add-btn", function () {
  // * Select Many IOTs Products
  let discountPrice =
    productInfo[$(this).attr("data-sku")]["bundle_builder_price"] !== ""
      ? productInfo[$(this).attr("data-sku")]["sale_price"] -
        productInfo[$(this).attr("data-sku")]["bundle_builder_price"]
      : 0;
  // * Showing Add and Count Button
  jQuery(this).siblings(".quantity").css("display", "block");
  jQuery(this).hide();

  // * Increment IOT Count
  iotCount++;

  // * Show In HTML IOT Count
  // document.querySelector("#js-iot-count").innerText = iotCount;
  // * Adding Product In List with Sku and IOT Quantity
  productSelectedList.push([
    $(this).attr("data-sku"),
    iotQuantity,
    discountPrice,
  ]);

  selectedIotList.push([$(this).attr("data-sku"), iotQuantity, discountPrice]);

  let totalSum = 0;
  productSelectedList.forEach((products) => {
    $("#js-total-product-count").html(0);

    totalSum += products[1];
  });
  $("#js-total-product-count").html(totalSum);

  // * Product Highlight Template
  productHighlightTemplate();

  // * Calculating Product Price
  productHighlightPrice();
});

// * Working On NVR Compare

$(document).on("click", "input[name='compare']", function () {
  if ($(this).prop("checked")) {
    $("#js-nvr-compare").css("display", "flex");
    $(this).addClass("active-compare");

    $("#js-compare-nvr").append(`
    <div  class="compare-div" data-compare-sku="${
      productInfo[$(this).data("sku")]["sku"]
    }"><span class="only-cross nvr-cross" data-sku="${
      productInfo[$(this).data("sku")]["sku"]
    }">X</span>
        <img src="${productInfo[$(this).data("sku")]["image_link"]}" />
        <h3>${productInfo[$(this).data("sku")]["title"]}</h3>
        <p>$${productInfo[$(this).data("sku")]["bundle_builder_price"]}</p>
    </div>
  `);

    compareNvrSku.push($(this).data("sku"));

    // $(".next-step").addClass("next-btn");
    // $(".pre-step").addClass("pre-btn");
    // $("#next-arrow, #pre-arrow").addClass("icon-arrow");
  } else if (!$(this).prop("checked")) {
    $(this).removeClass("active-compare");

    compareNvrSku.splice(compareNvrSku.indexOf($(this).data("sku")), 1);

    $(document)
      .find(`div[data-compare-sku=${productInfo[$(this).data("sku")]["sku"]}]`)
      .remove();
    if ($(document).find(".active-compare").length == 0) {
      $("#js-nvr-compare").css("display", "none");
    }

    // if (compareNvrSku.length == 0) {
    //   $(".next-step").removeClass("next-btn");
    //   $(".pre-step").removeClass("pre-btn");
    //   $("#next-arrow, #pre-arrow").removeClass("icon-arrow");
    // }
  } else {
    $(this).removeClass("active-compare");
  }
});

$(document).on("click", "#close-nvr-compare", function () {
  $(document)
    .find(".active-compare")
    .each(function () {
      $(this).prop("checked", false);
    });

  $(document).find(".active-compare").removeClass("active-compare");
  $(document).find("#js-compare-nvr").html("");
  compareNvrSku = [];
});

// * Working On Camera Compare

$(document).on("click", "input[name='compare-cam']", function () {
  if ($(this).prop("checked") && camCompareCount < 5) {
    camCompareCount++;
    $("#js-cam-compare").css("display", "flex");
    $(this).addClass("active-compare-cam");

    $("#js-compare-cam").append(`
    <div  class="compare-div" data-compare-sku="${
      productInfo[$(this).data("sku")]["sku"]
    }"><span class="only-cross cam-cross" data-sku="${
      productInfo[$(this).data("sku")]["sku"]
    }">X</span>
        <img src="${productInfo[$(this).data("sku")]["image_link"]}" />
        <h3>${productInfo[$(this).data("sku")]["title"]}</h3>
        <p>$${productInfo[$(this).data("sku")]["bundle_builder_price"]}</p>
    </div>
  `);

    // $(".next-step").addClass("next-btn");
    // $(".pre-step").addClass("pre-btn");
    // $("#next-arrow, #pre-arrow").addClass("icon-arrow");

    compareCamSku.push($(this).data("sku"));

    if (camCompareCount == 5) {
      $(document)
        .find("input[name='compare-cam']")
        .each((item, index) => {
          if (!$(index).hasClass("active-compare-cam")) {
            $(index).attr("disabled", true);
          }
        });
    }
  } else if (!$(this).prop("checked")) {
    $(this).removeClass("active-compare-cam");
    camCompareCount--;
    $(document)
      .find("input[name='compare-cam']")
      .each((item, index) => {
        if (!$(index).hasClass("active-compare-cam")) {
          $(index).removeAttr("disabled");
        }
      });
    compareCamSku.splice(compareCamSku.indexOf($(this).data("sku")), 1);

    $(document)
      .find(`div[data-compare-sku=${productInfo[$(this).data("sku")]["sku"]}]`)
      .remove();
    if ($(document).find(".active-compare-cam").length == 0) {
      $("#js-cam-compare").css("display", "none");
    }

    // if (compareCamSku.length == 0) {
    //   $(".next-step").removeClass("next-btn");
    //   $(".pre-step").removeClass("pre-btn");
    //   $("#next-arrow, #pre-arrow").removeClass("icon-arrow");
    // }
  } else {
    $(this).removeClass("active-compare-cam");
  }
});

// * Input Function for Camera
let pocCount = 0;
$(document).on("change", ".js-camera-count-input", function () {
  let camCheck = cameraCount;
  productSelectedList.forEach((product) => {
    // * Filter Sku From Product Selected List
    product.forEach((sku) => {
      if (sku == $(this).attr("data-sku")) {
        // productSelectedList[productSelectedList.indexOf(product)] = [
        //   productSelectedList[productSelectedList.indexOf(product)][0],
        //   parseInt($(this).val()),
        // ];
        camCheck -= parseInt(product[1]);
      }
    });
  });
  camCheck += parseInt($(this).val());
  if (camCheck <= totalCapableCamCount) {
    if (
      $(this).val() !== NaN &&
      $(this).val() !== "" &&
      $(this).val() !== undefined
    ) {
      //cameraCount += parseInt($(this).val());
      cameraCount = camCheck;

      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.forEach((sku) => {
          if (sku == $(this).attr("data-sku")) {
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).val()),
            ];
            //cameraCount -= parseInt(product[1]);
          }
        });
      });

      if (camCheck >= totalCapableCamCount) {
        $(".js-camera-add-btn").addClass("btn-secondary");
      } else {
        $(".js-camera-add-btn").removeClass("btn-secondary");
      }

      selectedCamList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.forEach((sku) => {
          if (sku == $(this).attr("data-sku")) {
            selectedCamList[selectedCamList.indexOf(product)] = [
              selectedCamList[selectedCamList.indexOf(product)][0],
              parseInt($(this).val()),
            ];
            //cameraCount -= parseInt(product[1]);
          }
        });
      });
      document.querySelector("#js-camera-count").innerText = cameraCount;

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();

      addPocText +=
        parseFloat($(this).attr("data-poc")) * parseInt($(this).val());

      addPocText -=
        parseInt(selectedCamerasList[$(this).attr("data-sku")]) *
        parseFloat($(this).attr("data-poc"));
      addPoc.innerText = addPocText.toFixed(2);

      // addPocText = pocCount;
      if (parseInt(addPocText) > parseInt(totalPoc)) {
        $("#js-poc-color").parent().removeClass("d-none");
        $("#js-poc-color").css("color", "#f00");
      } else {
        $("#js-poc-color").css("color", "#219653");
      }

      selectedCamerasList[$(this).attr("data-sku")] = $(this).val();
    } else {
      $(this).val(0);
      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.forEach((sku) => {
          if (sku == $(this).attr("data-sku")) {
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).val()),
            ];

            cameraCount -= parseInt(product[1]);
          }
        });
      });
      document.querySelector("#js-camera-count").innerText = cameraCount;

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();

      addPocText = parseFloat($(this).attr("data-poc")) * cameraCount;
      addPoc.innerText = addPocText.toFixed(2);

      if (parseInt(addPocText) > parseInt(totalPoc)) {
        $("#js-poc-color").parent().removeClass("d-none");
        $("#js-poc-color").css("color", "#f00");
      } else {
        $("#js-poc-color").css("color", "#219653");
      }
    }
  } else {
    let revert_val = 0;
    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          revert_val = product[1];
        }
      });
    });

    $(this).val(revert_val);
  }
});

// * Input Function For Junction Box
$(document).on("change", ".js-jbox-count-input", function () {
  productSelectedList.forEach((product) => {
    // * Filter Sku From Product Selected List
    if (
      $(this).val() !== NaN &&
      $(this).val() !== "" &&
      $(this).val() !== undefined
    ) {
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
        }
      });
    } else {
      $(this).val(0);
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
        }
      });
    }
  });
  // * Product Highlight Template
  productHighlightTemplate();

  // * Calculating Product Price
  productHighlightPrice();
});

// * Input Function For HDD
$(document).on("change", ".js-hdd-count-input", function () {
  // let hddCheck = maxHDDCount;
  // productSelectedList.forEach((product) => {
  //   // * Filter Sku From Product Selected List
  //   product.forEach((sku) => {
  //     if (sku == $(this).attr("data-sku")) {
  //       // productSelectedList[productSelectedList.indexOf(product)] = [
  //       //   productSelectedList[productSelectedList.indexOf(product)][0],
  //       //   parseInt($(this).val()),
  //       // ];
  //       hddCheck -= parseInt(product[1]);
  //     }
  //   });
  // });
  // hddCheck += parseInt($(this).val());
  if (
    $(this).val() !== NaN &&
    $(this).val() !== "" &&
    $(this).val() !== undefined
  ) {
    //cameraCount += parseInt($(this).val());
    // maxHDDCount = hddCheck;

    // if (hddCheck >= productInfo[nvrSkuBtn]["hdd_bays"]) {
    //   $(".js-hard-disk").addClass("btn-secondary");
    // } else {
    //   $(".js-hard-disk").removeClass("btn-secondary");
    // }
    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
          //maxHDDCount -= parseInt(product[1]);
        }
      });
    });

    if (hddCheck >= productInfo[nvrSkuBtn]["hdd_bays"]) {
      $(".js-hdd-add-btn").addClass("btn-secondary");
    } else {
      $(".js-hdd-add-btn").removeClass("btn-secondary");
    }

    selectedCamList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          selectedCamList[selectedCamList.indexOf(product)] = [
            selectedCamList[selectedCamList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
          //maxHDDCount -= parseInt(product[1]);
        }
      });
    });

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  } else {
    $(this).val(0);
    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];

          maxHDDCount -= parseInt(product[1]);
        }
      });
    });
    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  }
});

// * Input Function For IOT
$(document).on("change", ".js-iot-count-input", function () {
  let iotCheck = iotCount;
  productSelectedList.forEach((product) => {
    // * Filter Sku From Product Selected List
    product.forEach((sku) => {
      if (sku == $(this).attr("data-sku")) {
        // productSelectedList[productSelectedList.indexOf(product)] = [
        //   productSelectedList[productSelectedList.indexOf(product)][0],
        //   parseInt($(this).val()),
        // ];
        iotCheck -= parseInt(product[1]);
      }
    });
  });
  iotCheck += parseInt($(this).val());
  // if (iotCheck <= 2) {
  if (
    $(this).val() !== NaN &&
    $(this).val() !== "" &&
    $(this).val() !== undefined
  ) {
    // iotCount += parseInt($(this).val());
    iotCount = iotCheck;

    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];

          // iotCount -= parseInt(product[1]);
        }
      });
    });

    selectedIotList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          selectedIotList[selectedIotList.indexOf(product)] = [
            selectedIotList[selectedIotList.indexOf(product)][0],
            parseInt($(this).val()),
          ];

          // iotCount -= parseInt(product[1]);
        }
      });
    });
    // document.querySelector("#js-iot-count").innerText = iotCount;

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  } else {
    $(this).val(0);

    iotCount += parseInt($(this).val());

    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];

          iotCount -= parseInt(product[1]);
        }
      });
    });
    // document.querySelector("#js-iot-count").innerText = iotCount;

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  }
  // } else {
  //   // let revert_val = 0;
  //   // productSelectedList.forEach((product) => {
  //   //   // * Filter Sku From Product Selected List
  //   //   product.forEach((sku) => {
  //   //     if (sku == $(this).attr("data-sku")) {
  //   //       revert_val = product[1];
  //   //     }
  //   //   });
  //   // });
  //   // $(this).val(revert_val);
  // }
});

// * Input Function For Accessories
$(document).on("change", ".js-accessories-count-input", function () {
  if (
    $(this).val() !== NaN &&
    $(this).val() !== "" &&
    $(this).val() !== undefined
  ) {
    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
        }
      });
    });
    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  } else {
    $(this).val(0);
    productSelectedList.forEach((product) => {
      // * Filter Sku From Product Selected List
      product.forEach((sku) => {
        if (sku == $(this).attr("data-sku")) {
          productSelectedList[productSelectedList.indexOf(product)] = [
            productSelectedList[productSelectedList.indexOf(product)][0],
            parseInt($(this).val()),
          ];
        }
      });
    });
    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();
  }
});

$(document).on("click", "#close-cam-compare", function () {
  $(document)
    .find(".active-compare-cam")
    .each(function () {
      $(this).prop("checked", false);
    });
  $(document).find(".active-compare-cam").removeClass("active-compare-cam");
  $(document).find("#js-compare-cam").html("");
  $(document).find(".active-compare").removeClass("active-compare-cam");
  compareCamSku = [];
  camCompareCount = 0;
  if (camCompareCount < 5) {
    $(document)
      .find("input[name='compare-cam']")
      .each((item, index) => {
        if (!$(index).hasClass("active-compare-cam")) {
          $(index).attr("disabled", false);
        }
      });
  }
});

// * Working On Compare Button
$(document).on("click", "#js-show-nvr-compare", function () {
  document.querySelector("#js-compare-selected-nvr").innerHTML = `<td></td>`;
  document.querySelector(
    "#js-nvr-channel-container"
  ).innerHTML = `<th style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title=" Maximum number of cameras that can be paired with the NVR. This can be a combination of wired and Wi-Fi channels."
    ><img src="img/imp.png" /> Channels</a
  >
</th>`;
  document.querySelector(
    "#js-nvr-wired-container"
  ).innerHTML = `<th style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title="Maximum number of cameras that can be paired with the NVR using CAT5 (or higher) cable."
    ><img src="img/imp.png" /> Wired
    Channels</a
  >
</th>`;
  document.querySelector(
    "#js-nvr-wl-container"
  ).innerHTML = `<th style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title=" Maximum number of cameras that can be paired with the NVR using Wi-Fi connection (Fusion)."
    ><img src="img/imp.png" /> Wi-Fi
    Channels</a
  >
</th>`;
  document.querySelector(
    "#js-nvr-fps-container"
  ).innerHTML = `<th class="no-bot-bor" style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title=" Frames per second. A numerical value that indicates how fast still images flicker for every second to create movement in videos."
    ><img src="img/imp.png" /> FPS</a
  >
</th>`;
  document.querySelector(
    "#js-nvr-ls-container"
  ).innerHTML = `<th class="no-bot-bor" style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title="Included in the NVR is a built-in security-grade hard drive that has been designed to meet the demands of 24/7 surveillance recording."
    ><img src="img/imp.png" /> Included Local
    Storage</a
  >
</th>`;
  document.querySelector(
    "#js-nvr-coc-container"
  ).innerHTML = `<th class="no-bot-bor" style="display: block;">
  <a href="#" class="tip" data-toggle="tooltip" 
  title="Security cameras with listen-in audio come with a built-in microphone that can hear and record audio. Two-way talk cameras also include a speaker that allows you to communicate to those within earshot of the camera."
    ><img src="img/imp.png" /> Remote Viewing</a
  >
</th>`;
  compareNvrSku.forEach((nvrSku) => {
    document.querySelector("#js-compare-selected-nvr").insertAdjacentHTML(
      "beforeend",
      `
      
      <td style="border: 1px solid rgb(216, 216, 216);padding-top:50px" >
    <div
      class="card mar-auto"
      style="width: 70%"
    >
      <div class="img-wrapper">
        <span class="recom">Recommended</span>
        <a
          href="${productInfo[nvrSku]["link"]}"
          target="_blank"
          rel="noreferrer "
        >
          <img src="${productInfo[nvrSku]["image_link"]}" alt="${
        productInfo[nvrSku]["title"]
      }" width="100%"/></a>
      </div>
      <div class="card-body">
        <a
          href="${productInfo[nvrSku]["link"]}"
          target="_blank"
          rel="noreferrer "
          class="text-decoration-none"
        >
          <h5 class="card-title">${productInfo[nvrSku]["title"]}</h5>
        </a>
        <ul class="features">
          <li>${productInfo[nvrSku]["sku"]}</li>
          <li><img src="img/small.svg" /></li>
          <li>${productInfo[nvrSku]["poe_budget"]}W</li>
        </ul>
        <div class="yotpo bottomLine"
              data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
              data-domain="{{shop.permanent_domain | escape }}"
              data-product-id="{{ product.id }}"
              data-product-models="{{ product.id }}"
              data-name="{{ product.title | escape }}"
              data-url="{{ shop.url }}{{ product.url }}"
              data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
              data-description="{{ product.description | escape }}"
              data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
            </div>
        <p class="price">$${
          productInfo[nvrSku]["bundle_builder_price"]
            ? productInfo[nvrSku]["bundle_builder_price"]
            : productInfo[nvrSku]["sale_price"]
        }</p>
      </div>
    </div>
  </td>`
    );

    nvrCompareTemplate(productInfo[nvrSku]);
  });
});

// * Working On Compare Button
$(document).on("click", "#js-show-cam-compare", function () {
  document.querySelector("#js-compare-selected-cam").innerHTML = `<td></td>`;
  NvrClearRelatedCameraCompare();

  compareCamSku.forEach((camSku) => {
    document.querySelector("#js-compare-selected-cam").insertAdjacentHTML(
      "beforeend",
      `
      <td style="border: 1px solid rgb(216, 216, 216);padding-top:50px">
    <div
      class="card mar-auto"
      style="width: 70%"
    >
      <div class="img-wrapper">
        <span class="recom">Recommended</span>
        <a
          href="${productInfo[camSku]["link"]}"
          target="_blank"
          rel="noreferrer "
        >
          <img src="${productInfo[camSku]["image_link"]}" alt="${
        productInfo[camSku]["title"]
      }" width="100%"/></a>
      </div>
      <div class="card-body">
        <a
          href="${productInfo[camSku]["link"]}"
          target="_blank"
          rel="noreferrer "
          class="text-decoration-none"
        >
          <h5 class="card-title">${productInfo[camSku]["title"]}</h5>
        </a>
        <ul class="features">
          <li>${productInfo[camSku]["sku"]}</li>
          <li><img src="img/small.svg" /></li>
          <li>${productInfo[camSku]["poe_consumption"]}W</li>
        </ul>
        <div class="yotpo bottomLine"
              data-appkey="tcuIDHhS2MFEJnItZOYIUpfFRgIMOSwfQXLIFA3f"
              data-domain="{{shop.permanent_domain | escape }}"
              data-product-id="{{ product.id }}"
              data-product-models="{{ product.id }}"
              data-name="{{ product.title | escape }}"
              data-url="{{ shop.url }}{{ product.url }}"
              data-image-url="{{ product.featured_image | product_img_url: 'large' |replace: '?', '%3F' | replace: '&','%26'}}"
              data-description="{{ product.description | escape }}"
              data-bread-crumbs="{% for tag in product.tags %}{{ tag | escape }};{% endfor %}">
            </div>
        <p class="price">$${
          productInfo[camSku]["bundle_builder_price"]
            ? productInfo[camSku]["bundle_builder_price"]
            : productInfo[camSku]["sale_price"]
        }</p>
      </div>
    </div>
  </td>`
    );

    NvrRelatedCameraCompare(productInfo[camSku]);
  });
});

$(document).on("click", "input.js-iot-count-btn", function () {
  // * Getting Plus Icon Number
  let a = jQuery(this).closest(".quantity").find(".qty");

  // * Check If Minus Class Available
  if ($(this).hasClass("minus")) {
    // * Check If IOT Count and Plus Icon Value Greater Then 0
    if (iotCount > 0 && a.val() > 0) {
      // * Decrement IOT Count
      iotCount--;

      // * Show In HTML IOT Count
      // document.querySelector("#js-iot-count").innerText = iotCount;

      // * Decrement
      a.val(parseFloat(a.val()) - 1);

      if (parseInt(iotCount) < 2) {
        $(".js-iot-add-btn").removeClass("btn-secondary");
      }

      // * Increment Max IOT Value So That Max IOT Selection Can Decrease
      maxIotSelect++;

      if (productSelectedList.length !== 0) {
        // * Extracting Product From Product Selected List
        productSelectedList.forEach((product) => {
          // * Filter Sku From Product Selected List
          product.filter((sku) => {
            if (sku == $(this).attr("data-sku")) {
              // * Update Camera Quantity In Index Of Previously Selected Product
              /**
               * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
               * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
               */
              productSelectedList[productSelectedList.indexOf(product)] = [
                productSelectedList[productSelectedList.indexOf(product)][0],
                parseInt($(this).siblings(".qty").val()),
              ];
            }
          });
        });

        // * Update Product List When Click On Plus/Minus Button
        // ! Function Is Not Working. It Not Throw Any Error But It Not Update Product List
        // TODO : Fix This Issue
        // updateProductQuantity();
      }

      // * Product Highlight Template
      productHighlightTemplate();

      // * Calculating Product Price
      productHighlightPrice();

      selectedIotList.forEach((item) => {
        item.filter((i) => {
          if (i == $(this).attr("data-sku")) {
            selectedIotList[selectedIotList.indexOf(item)] = [
              selectedIotList[selectedIotList.indexOf(item)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });

      let totalSum = 0;
      productSelectedList.forEach((products) => {
        $("#js-total-product-count").html(0);

        totalSum += products[1];
      });
      $("#js-total-product-count").html(totalSum);
    }

    // * Check If Minus Class Available
  } else if ($(this).hasClass("plus")) {
    // * Check If Max IOT Selection Smaller Then 2

    // * Decrement Max IOT Value So That Max IOT Selection Can Increase
    maxIotSelect--;

    // * Increase IOT Count
    iotCount++;

    // if (parseInt(iotCount) === 2) {
    //   $(".js-iot-add-btn").addClass("btn-secondary");
    // }

    // * Show In HTML IOT Count
    // document.querySelector("#js-iot-count").innerText = iotCount;

    a.val(parseFloat(a.val()) + 1);

    if (maxIotSelect <= 0) {
      maxIotSelect = 0;
    }

    // * Checking If Product List Is Empty
    if (productSelectedList.length !== 0) {
      // * Extracting Product From Product Selected List
      productSelectedList.forEach((product) => {
        // * Filter Sku From Product Selected List
        product.filter((sku) => {
          if (sku == $(this).attr("data-sku")) {
            // * Update Camera Quantity In Index Of Previously Selected Product
            /**
             * * In This Logic,in 'productSelectedList' found Index Of Selected Product using 'productSelectedList.indexOf(product)'
             * * Then Insert Sku and Camera Quantity In Index Of Previously and Same Selected Product Place
             */
            productSelectedList[productSelectedList.indexOf(product)] = [
              productSelectedList[productSelectedList.indexOf(product)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        });
      });

      let totalSum = 0;
      productSelectedList.forEach((products) => {
        $("#js-total-product-count").html(0);

        totalSum += products[1];
      });
      $("#js-total-product-count").html(totalSum);
    }

    // * Product Highlight Template
    productHighlightTemplate();

    // * Calculating Product Price
    productHighlightPrice();

    selectedIotList.forEach((item) => {
      item.filter((i) => {
        if (i == $(this).attr("data-sku")) {
          if (item !== -1) {
            selectedIotList[selectedIotList.indexOf(item)] = [
              selectedIotList[selectedIotList.indexOf(item)][0],
              parseInt($(this).siblings(".qty").val()),
            ];
          }
        }
      });
    });

    return false;
  }
});

/**
 * * For HTML and Design Purpose
 */
$(document).ready(function () {
  $(".js-modal-cart-btn").click(function () {
    $(".blue-area").addClass("blue-area-fixed");
    $(".cart-mob").addClass("cart-mob-open");
    $(".next-step").css("display", "none");
    $(".add-to-cart").css("display", "");
    $(".hide-shopping").css("display", "none");
    $(".js-modal-cart-btn").hide();
    $(".js-modal-btn-close").css("display", "");
  });

  $(".hide-shopping").click(function () {
    $(".blue-area").addClass("blue-area-fixed");
    $(".cart-mob").addClass("cart-mob-open");
    $(".next-step").css("display", "none");
    $(".add-to-cart").css("display", "");
    $(".hide-shopping").css("display", "none");
    $(".js-modal-cart-btn").hide();
    $(".js-modal-btn-close").css("display", "");
  });
  $("span.cross").click(function () {
    $(".blue-area").removeClass("blue-area-fixed");
    $(".js-modal-cart-btn").css("display", "");
    $(".js-modal-btn-close").css("display", "none");
    $(".cart-mob").removeClass("cart-mob-open");
    $(".next-step").css("display", "");
    $(".add-to-cart").css("display", "none");

    $(".hide-shopping").css("display", "");
  });

  $(".js-modal-btn-close").click(function () {
    $(".blue-area").removeClass("blue-area-fixed");
    $(".js-modal-cart-btn").css("display", "");
    $(".js-modal-btn-close").css("display", "none");
    $(".cart-mob").removeClass("cart-mob-open");
    $(".next-step").css("display", "");
    $(".add-to-cart").css("display", "none");

    $(".hide-shopping").css("display", "");
  });

  // $(document).on("click", ".only-cross", function () {
  //   $(this).parents(".compare-div").hide();
  //   $(document)
  //     .find(".active-compare")
  //     .each(function () {
  //       $(this).prop("checked", false);
  //     });
  //   compareNvrSku = [];
  // });

  $(document).on("click", ".nvr-cross", function () {
    $(document)
      .find(`.compare-div[data-compare-sku=${$(this).data("sku")}]`)
      .remove();

    $(document)
      .find(`.active-compare[data-sku=${$(this).data("sku")}]`)
      .prop("checked", false);

    if ($(`#js-compare-nvr`).children().length == 0) {
      $(`#js-nvr-compare`).hide();
    }

    $(document)
      .find(`.active-compare[data-sku=${$(this).data("sku")}]`)
      .removeClass("active-compare");

    compareNvrSku.splice($(this).data("sku"), 1);

    // if (compareNvrSku.length == 0) {
    //   $(".next-step").removeClass("next-btn");
    //   $(".pre-step").removeClass("pre-btn");
    //   $("#next-arrow, #pre-arrow").removeClass("icon-arrow");
    // }
  });

  $(document).on("click", ".cam-cross", function () {
    $(document)
      .find(`.compare-div[data-compare-sku=${$(this).data("sku")}]`)
      .remove();

    $(document)
      .find(`.active-compare-cam[data-sku=${$(this).data("sku")}]`)
      .prop("checked", false);

    $(document)
      .find(`.active-compare-cam[data-sku=${$(this).data("sku")}]`)
      .removeClass("active-compare-cam");

    if ($(`#js-compare-cam`).children().length == 0) {
      $(`#js-cam-compare`).hide();
    }

    $(document)
      .find(`.active-compare[data-sku=${$(this).data("sku")}]`)
      .removeClass("active-compare-cam");

    compareCamSku.splice($(this).data("sku"), 1);

    // if (compareCamSku.length == 0) {
    //   $(".next-step").removeClass("next-btn");
    //   $(".pre-step").removeClass("pre-btn");
    //   $("#next-arrow, #pre-arrow").removeClass("icon-arrow");
    // }

    camCompareCount--;
    if (camCompareCount < 5) {
      $(document)
        .find("input[name='compare-cam']")
        .each((item, index) => {
          if (!$(index).hasClass("active-compare-cam")) {
            $(index).attr("disabled", false);
          }
        });
    }
  });

  $('[data-toggle="tooltip"]').tooltip();

  // $(".blue-btn").click(function () {
  //   location.reload();
  // });
  $(".close-btn").click(function () {
    $(".compare-box").hide();
    // $(".next-step").removeClass("next-btn");
    // $(".pre-step").removeClass("pre-btn");
    // $("#next-arrow, #pre-arrow").removeClass("icon-arrow");
  });
});

$(document).ready(function () {
  // Tooltip
  $('[data-bs-toggle="tooltip"]').tooltip();

  // Disable Button Until NVR Select
  $(".next-step").attr("disabled", true);

  $(".compare").click(function () {
    $("fieldset.step1 th").css("display", "revert");
    $("fieldset.step1 tbody").css("display", "revert");
    $(".step1 table td").css("border", "1px solid #D8D8D8");
    $(".card").addClass("mar-auto");

    $(this).hide();
    $(".compare-close").css("display", "block");
  });
  $(".compare-close").click(function () {
    $("fieldset.step1 th").css("display", "none");
    $("fieldset.step1 tbody").css("display", "none");
    $(".step1 table td").css("border", "0");
    $(this).hide();
    $(".compare").show();
    $(".card").removeClass("mar-auto");
  });

  $(".compare-2").click(function () {
    $("fieldset.step2 th").css("display", "revert");
    $("fieldset.step2 tbody").css("display", "revert");
    $(".step2 table td").css("border", "1px solid #D8D8D8");
    $(this).hide();
    $(".compare-close-2").css("display", "block");
    $(".card").addClass("mar-auto");
  });
  $(".compare-close-2").click(function () {
    $("fieldset.step2 th").css("display", "none");
    $("fieldset.step2 tbody").css("display", "none");
    $(".step2 table td").css("border", "0");
    $(this).hide();
    $(".compare-2").show();
    $(".card").removeClass("mar-auto");
  });

  // For NVR
  $(document).on("click", "a.btn.js-nvr-add-btn", function () {
    $(document)
      .find("a.btn.js-nvr-add-btn")
      .siblings(".quantity")
      .css("display", "none");
    $(document).find("a.btn.js-nvr-add-btn").css("display", "");
    $(this).siblings(".quantity").css("display", "block");
    $(this).hide();
    // $(".save-for-later").css("display", "flex");
    $(".next-step").addClass("show-next-button");
    $(this).siblings(".quantity").find(".qty").val(1);
    nvrQuantity = 1;
    $(document).find("a.btn.js-nvr-add-btn").addClass("btn-secondary");
    if ($(this).siblings(".quantity").find(".qty").val() == 1) {
    }

    $(document).find("#js-total-product-count-1").text(1);

    // Disable Button Until NVR Select
    $(".next-step").attr("disabled", false);
  });
  // $(document).on("click", ".js-nvr-count-btn", function () {
  //   if ($(this).hasClass("minus")) {
  //     // * If Quantity is 1 then hide minus button
  //     if (parseInt($(this).siblings(".qty").val()) === 0) {
  //       // $(".save-for-later").css("display", "none");
  //       $(".next-step").removeClass("show-next-button");
  //     }
  //   } else if ($(this).hasClass("plus")) {
  //     // $(".save-for-later").css("display", "flex");
  //     $(".next-step").addClass("show-next-button");
  //   }
  //   nvrQuantity = parseInt($(this).siblings(".qty").val());
  // });

  // For Camera
  $(document).on("click", ".js-junction-box", function () {
    $(this).siblings(".quantity").css("display", "block");
    $(this).hide();
    // $(".save-for-later").css("display", "flex");
    $(".next-step").addClass("show-next-button");
  });

  $(document).on("click", "#next-bundle", function () {
    $("#next").trigger("click");
  });
  // // For Camera
  // $(document).on("click", "a.js-iot-add-btn", function () {
  //   $(this).siblings(".quantity").css("display", "block");
  //   $(this).hide();
  // $(".save-for-later").css("display", "flex");
  //   $(".next-step").addClass("show-next-button");
  // });
  $(".next-step").click(function () {
    $(window).scrollTop(0);
    var step = $(this).attr("data-step");

    $(".bundle-price").show();
    if ($(this).attr("data-step") == "2" && addPocText <= totalPoc) {
      $(this).attr("data-step", "3");
      var step_get = $(".next-step").attr("data-step");

      $(".steps").hide();
      $(".step" + step_get).show();
    } else if ($(this).attr("data-step") == "3") {
      $(this).attr("data-step", "4");
      var step_get = $(".next-step").attr("data-step");

      $(".steps").hide();
      $(".step" + step_get).show();
    } else if ($(this).attr("data-step") == "1") {
      $(this).attr("data-step", "2");
      var step_get = $(".next-step").attr("data-step");
      $(".next-step").removeClass("show-next-button");

      $(".steps").hide();
      $(".step" + step_get).show();
    } else if ($(this).attr("data-step") == "4") {
      $(".main-div").hide();
      $(".cart-section").css("display", "flex");
    }
  });

  $("#js-change-recorder").click(function () {
    const stepHTML = document.querySelector("#steps");
    currentStep = 1;
    $(".steps").hide();
    $(".step1").show();

    $("#js-main-container").removeClass("col-md-9").addClass("col-md-12");
    // $("#js-j-box-title").css("display", "none");

    $("#right-slide-btn").css("display", "block");
    $("#left-slide-btn").css("display", "block");
    $(".only-first").css("display", "");
    $(".next-step").attr("data-step", "1");
    $(".bundle-price").hide();
    stepHTML.innerText = 1;
    currentProgressBar(currentStep);
    $(".next-step").removeClass("show-next-button");
    $(document).find("a.btn.js-nvr-add-btn").css("display", "");
    $(document).find(".quantity").css("display", "none");
    NvrClearRelatedCameraCompare();

    $(".card").removeClass("mar-auto");

    $(".js-nvr-add-btn").removeClass("btn-secondary");

    $(document).find("a.btn.js-camera-add-btn").css("display", "");

    $(document).find(".quantity").css("display", "none");

    cameraCount = 0;
    document.querySelector("#js-select-nvr").innerText = "";
    // document.querySelector("#js-j-box-container").innerHTML = "";

    document.querySelector("#js-select-nvr-poc").innerText = "";

    document.querySelector("#total-cam-poc-cal").innerText = "";

    document.querySelector("#total-nvr-poc-cal").innerText = "";
    clearShowSelectedCamTemplate("#js-select-cam");

    document.querySelector("#extra-poc-cam").innerText = "";
    document.querySelector("#js-camera-count").innerText = 0;
    addPocText = 0;
    addPoc.innerHTML = 0;

    selectedCamList = [];

    if ($("#cartupModal").modal("show")) {
      $("#cartupModal").modal("hide");
    }

    document.querySelector("#js-camera-count").innerText = 0;
    addPoc.innerText = 0;

    $(document)
      .find("input[name='compare']")
      .each(function () {
        $(this).removeClass("active-compare");
        $(this).prop("checked", false);
      });

    $(document).find("#js-compare-nvr").html("");
    $("#js-nvr-compare").css("display", "none");
    compareNvrSku = [];

    $(document)
      .find("input[name='compare-cam']")
      .each(function () {
        $(this).removeClass("active-compare-cam");
        $(this).prop("checked", false);
      });

    $(document).find("#js-compare-cam").html("");
    $("#js-cam-compare").css("display", "none");
    compareCamSku = [];

    productHighlightTemplate();
    productResetHighlightPrice();

    camCompareCount = 0;

    $("#js-accessories-ss")
      .find(".btn.btn-primary.js-junction-box")
      .css("display", "");

    document.querySelector("#viewSelectedItem").innerHTML = "";
    iotCount = 0;

    // document.querySelector("#js-iot-count").innerText = iotCount;
    selectedIotList = [];

    document.querySelector("#viewSelectedItemIot").innerHTML = ``;
    $("#previous-btn").css("display", "none");
  });
});

$("#js-change-camera").click(function () {
  // let productSelectedList = [];
  const stepHTML = document.querySelector("#steps");
  currentStep = 2;
  $(".steps").hide();
  $(".step2").show();
  if ($("#cartupModal").modal("show")) {
    $("#cartupModal").modal("hide");
  }

  $("#right-slide-btn").css("display", "block");
  $("#left-slide-btn").css("display", "block");

  // $("#js-j-box-title").css("display", "none");

  $(".next-step").attr("data-step", "2");
  $(".bundle-price").show();
  stepHTML.innerText = 2;
  currentProgressBar(currentStep);
  $(".next-step").removeClass("show-next-button");
  $(document).find("a.btn.js-camera-add-btn").css("display", "");
  $(document).find("a.btn.js-junction-box").css("display", "");

  $(document).find(".quantity").css("display", "none");

  cameraCount = 0;

  document.querySelector("#viewSelectedItem").innerHTML = "";
  NvrClearRelatedCameraCompare();

  ShowNvrRelatedCamera(productJson, totalProductSelected.nvr.sku);
  document.querySelector("#js-select-nvr").innerText = "";

  document.querySelector("#js-select-nvr-poc").innerText = "";

  document.querySelector("#total-cam-poc-cal").innerText = "";

  document.querySelector("#total-nvr-poc-cal").innerText = "";
  clearShowSelectedCamTemplate("#js-select-cam");

  // document.querySelector("#js-j-box-container").innerHTML = "";
  document.querySelector("#js-selected-cam-num1").innerText = 0;
  document.querySelector("#extra-poc-cam").innerText = "";
  document.querySelector("#js-camera-count").innerText = 0;
  selectedCamList = [];

  let discountPrice =
    productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"] !== ""
      ? productInfo[totalProductSelected.nvr.sku]["sale_price"] -
        productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"]
      : 0;

  addPocText = 0;
  addPoc.innerHTML = 0;
  productSelectedList = [];
  productSelectedList.push([
    totalProductSelected.nvr.sku,
    totalProductSelected.nvr.quantity,
    discountPrice,
  ]);
  $(document).find("a.btn.js-iot-add-btn").css("display", "");
  $(document).find(".quantity").css("display", "none");
  iotCount = 0;

  // document.querySelector("#js-iot-count").innerText = 0;
  productHighlightTemplate();
  productCamHighlightPrice();

  $(".card").removeClass("mar-auto");

  $(document)
    .find("input[name='compare-cam']")
    .each(function () {
      $(this).removeClass("active-compare-cam");
      $(this).prop("checked", false);
    });

  $(document).find("#js-compare-cam").html("");
  $("#js-cam-compare").css("display", "none");
  compareCamSku = [];

  camCompareCount = 0;

  selectedIotList = [];

  document.querySelector("#viewSelectedItemIot").innerHTML = ``;

  $("#previous-btn").attr("data-step", "2");
});

$("#js-change-iot").click(function () {
  // let productSelectedList = [];
  const stepHTML = document.querySelector("#steps");
  currentStep = 3;
  $(".steps").hide();
  $(".step3").show();

  $(".next-step").attr("data-step", "3");
  $(".bundle-price").show();
  stepHTML.innerText = 3;
  currentProgressBar(currentStep);

  $(document).find("a.btn.js-iot-add-btn").css("display", "");
  $(document).find(".quantity").css("display", "none");
  iotCount = 0;

  // document.querySelector("#js-iot-count").innerText = 0;
  productSelectedList = [];

  const iotTabTemplate1 = document.querySelector("#cameraTemplate");
  iotTabTemplate1.innerHTML = "";

  const iotTabTemplate2 = document.querySelector("#wifiCameraTemplate");
  iotTabTemplate2.innerHTML = "";

  const iotTabTemplate3 = document.querySelector("#doorTemplate");
  iotTabTemplate3.innerHTML = "";

  const iotTabTemplate4 = document.querySelector("#floodTemplate");
  iotTabTemplate4.innerHTML = "";

  const iotTabTemplate5 = document.querySelector("#sensorTemplate");
  iotTabTemplate5.innerHTML = "";

  let discountPrice =
    productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"] !== ""
      ? productInfo[totalProductSelected.nvr.sku]["sale_price"] -
        productInfo[totalProductSelected.nvr.sku]["bundle_builder_price"]
      : 0;

  allIotProduct(productJson);
  productSelectedList.push(
    [
      totalProductSelected.nvr.sku,
      totalProductSelected.nvr.quantity,
      discountPrice,
    ],
    ...selectedCamera
  );
  // productSelectedList = [];
  // productSelectedList = selectedCamera;
  productHighlightTemplate();
  productHighlightPrice();
  selectedIotList = [];

  document.querySelector("#viewSelectedItemIot").innerHTML = ``;

  $("#previous-btn").attr("data-step", "3");
});

const stepHTML = document.querySelector("#steps");
const nextBtn = document.querySelector("#next");
const totalStep = document.querySelector("#totalStep").innerText;
const startBar = document.querySelector("#start-bar");
const endBar = document.querySelector("#end-bar");
let currentStep = 1;
const currentProgressBar = (currentStep) => {
  let endBarPercent = parseFloat(100 / totalStep) * (currentStep - 1);
  endBarPercent = endBarPercent.toFixed();
  endBar.style.width = endBarPercent + "%";
  if (currentStep == totalStep) {
    endBar.style.width = 90 + "%";
  }

  let startBarPercent = parseFloat(100 / totalStep) * currentStep;
  startBarPercent = startBarPercent.toFixed();
  startBar.style.width = 25 + "%";
};
currentProgressBar(currentStep);

stepHTML.innerText = "1";

// let shopifyURL = new URLSearchParams(window.location.search);
// // console.log(shopifyURL.get("url").hostname);
// let domainName = new URL(shopifyURL.get("url"));
// console.log(domainName.hostname);
// * For View Cart When Bundle is Ready
// ! If Comment Please Uncomment
$(document).on("click", "#product-cart", function () {
  $(".flexy-new").hide();
  // shopifyProduct.items = [];

  let f_url = `https://www.lorex.com/cart/update?`;

  productSelectedList.forEach((items) => {
    let url = new URL(productInfo[items[0]].link);
    let params = new URLSearchParams(url.search);

    let shopifyId = params.get("variant")
      ? params.get("variant")
      : productInfo[items[0]].id;

    f_url += `updates[${shopifyId}]=${items[1]}&`;

    shopifyProduct.draft_order.line_items.push({
      // variant_id: Number(shopifyId),
      title: productInfo[items[0]]["title"],
      taxable: false,
      quantity: items[1],
      sku: productInfo[items[0]]["sku"],
      price: productInfo[items[0]]["sale_price"],
      applied_discount: {
        value_type: "fixed_amount",
        value: Number(Number(items[2]).toFixed(2)),
        amount: 10,
      },
    });
  });

  // shopifyProduct.draft_order.line_items.push({
  //   variant_id: 41321165258942,
  //   quantity: 2,
  //   applied_discount: {
  //     value_type: "fixed_amount",
  //     value: 10,
  //     amount: 10,
  //   },
  // });
  // * For Redirect Cart
  // window.open(f_url, "_blank");
  // location.reload();

  const fetch_shopify = async () => {
    console.log(shopifyProduct);
    let url = await fetch("./shopify.php", {
      method: "POST", // *GET, POST, PUT, DELETE, etc.
      mode: "cors",
      headers: {
        "Content-Type": "application/json",
        // 'Content-Type': 'application/x-www-form-urlencoded',
      },
      body: JSON.stringify(shopifyProduct),
    });
    let resp = await url.text();

    return resp;
  };

  fetch_shopify().then((resp) => {
    let data = JSON.parse(resp);
    console.log(data);
    if (data["success"] == 200) {
      let url = data["result"]["draft_order"];
      console.log(url["invoice_url"]);
      // $(document).find("#takeTimeToLoad").modal("hide");
      // $(document).find("#redirectToInvoice").modal("show");
      setTimeout(() => {
        // $(document).find("#redirectLink").attr("href", url["invoice_url"]);
        window.open(url["invoice_url"], "_blank");
        window.location.reload();
      }, 1000);
    }
  });
});

// * For Add To Cart
$(document).on("click", ".add-to-cart", function () {
  // shopifyProduct.items = [];
  let f_url = `https://www.lorex.com/cart/update?`;
  productSelectedList.forEach((items) => {
    let url = new URL(productInfo[items[0]].link);
    let params = new URLSearchParams(url.search);

    let shopifyId = params.get("variant")
      ? params.get("variant")
      : productInfo[items[0]].id;
    f_url += `updates[${shopifyId}]=${items[1]}&`;
    // shopifyProduct.items.push({
    //   id: shopifyId,
    //   quantity: items[1],
    // });
  });

  // * For Redirect Cart
  window.open(f_url, "_blank");
  location.reload();
});
